// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_SHARED_INTERNAL_H_
#define CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace app_management {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  PageHandlerFactory_CreatePageHandler_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandlerFactory_CreatePageHandler_Params_Data));
      new (data()) PageHandlerFactory_CreatePageHandler_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandlerFactory_CreatePageHandler_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandlerFactory_CreatePageHandler_Params_Data>(index_);
    }
    PageHandlerFactory_CreatePageHandler_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data page;
  mojo::internal::Handle_Data handler;
  uint8_t padfinal_[4];

 private:
  PageHandlerFactory_CreatePageHandler_Params_Data();
  ~PageHandlerFactory_CreatePageHandler_Params_Data() = delete;
};
static_assert(sizeof(PageHandlerFactory_CreatePageHandler_Params_Data) == 24,
              "Bad sizeof(PageHandlerFactory_CreatePageHandler_Params_Data)");
class  PageHandler_GetApps_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageHandler_GetApps_Params_Data));
      new (data()) PageHandler_GetApps_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageHandler_GetApps_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageHandler_GetApps_Params_Data>(index_);
    }
    PageHandler_GetApps_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PageHandler_GetApps_Params_Data();
  ~PageHandler_GetApps_Params_Data() = delete;
};
static_assert(sizeof(PageHandler_GetApps_Params_Data) == 8,
              "Bad sizeof(PageHandler_GetApps_Params_Data)");
class  Page_OnAppsAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Page_OnAppsAdded_Params_Data));
      new (data()) Page_OnAppsAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Page_OnAppsAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Page_OnAppsAdded_Params_Data>(index_);
    }
    Page_OnAppsAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> ids;

 private:
  Page_OnAppsAdded_Params_Data();
  ~Page_OnAppsAdded_Params_Data() = delete;
};
static_assert(sizeof(Page_OnAppsAdded_Params_Data) == 16,
              "Bad sizeof(Page_OnAppsAdded_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace app_management

#endif  // CHROME_BROWSER_UI_WEBUI_APP_MANAGEMENT_APP_MANAGEMENT_MOJOM_SHARED_INTERNAL_H_