// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_INTERNAL_H_
#define CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace chrome {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  NetworkEasterEgg_GetHighScore_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkEasterEgg_GetHighScore_Params_Data));
      new (data()) NetworkEasterEgg_GetHighScore_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkEasterEgg_GetHighScore_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkEasterEgg_GetHighScore_Params_Data>(index_);
    }
    NetworkEasterEgg_GetHighScore_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  NetworkEasterEgg_GetHighScore_Params_Data();
  ~NetworkEasterEgg_GetHighScore_Params_Data() = delete;
};
static_assert(sizeof(NetworkEasterEgg_GetHighScore_Params_Data) == 8,
              "Bad sizeof(NetworkEasterEgg_GetHighScore_Params_Data)");
class  NetworkEasterEgg_GetHighScore_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkEasterEgg_GetHighScore_ResponseParams_Data));
      new (data()) NetworkEasterEgg_GetHighScore_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkEasterEgg_GetHighScore_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkEasterEgg_GetHighScore_ResponseParams_Data>(index_);
    }
    NetworkEasterEgg_GetHighScore_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t high_score;
  uint8_t padfinal_[4];

 private:
  NetworkEasterEgg_GetHighScore_ResponseParams_Data();
  ~NetworkEasterEgg_GetHighScore_ResponseParams_Data() = delete;
};
static_assert(sizeof(NetworkEasterEgg_GetHighScore_ResponseParams_Data) == 16,
              "Bad sizeof(NetworkEasterEgg_GetHighScore_ResponseParams_Data)");
class  NetworkEasterEgg_UpdateHighScore_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(NetworkEasterEgg_UpdateHighScore_Params_Data));
      new (data()) NetworkEasterEgg_UpdateHighScore_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    NetworkEasterEgg_UpdateHighScore_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<NetworkEasterEgg_UpdateHighScore_Params_Data>(index_);
    }
    NetworkEasterEgg_UpdateHighScore_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t high_score;
  uint8_t padfinal_[4];

 private:
  NetworkEasterEgg_UpdateHighScore_Params_Data();
  ~NetworkEasterEgg_UpdateHighScore_Params_Data() = delete;
};
static_assert(sizeof(NetworkEasterEgg_UpdateHighScore_Params_Data) == 16,
              "Bad sizeof(NetworkEasterEgg_UpdateHighScore_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_INTERNAL_H_