// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_H_
#define CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/common/network_easter_egg.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace chrome {
namespace mojom {


}  // namespace mojom
}  // namespace chrome

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace chrome {
namespace mojom {
// Interface base classes. They are used for type safety check.
class NetworkEasterEggInterfaceBase {};

using NetworkEasterEggPtrDataView =
    mojo::InterfacePtrDataView<NetworkEasterEggInterfaceBase>;
using NetworkEasterEggRequestDataView =
    mojo::InterfaceRequestDataView<NetworkEasterEggInterfaceBase>;
using NetworkEasterEggAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NetworkEasterEggInterfaceBase>;
using NetworkEasterEggAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NetworkEasterEggInterfaceBase>;
class NetworkEasterEgg_GetHighScore_ParamsDataView {
 public:
  NetworkEasterEgg_GetHighScore_ParamsDataView() {}

  NetworkEasterEgg_GetHighScore_ParamsDataView(
      internal::NetworkEasterEgg_GetHighScore_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::NetworkEasterEgg_GetHighScore_Params_Data* data_ = nullptr;
};

class NetworkEasterEgg_GetHighScore_ResponseParamsDataView {
 public:
  NetworkEasterEgg_GetHighScore_ResponseParamsDataView() {}

  NetworkEasterEgg_GetHighScore_ResponseParamsDataView(
      internal::NetworkEasterEgg_GetHighScore_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t high_score() const {
    return data_->high_score;
  }
 private:
  internal::NetworkEasterEgg_GetHighScore_ResponseParams_Data* data_ = nullptr;
};

class NetworkEasterEgg_UpdateHighScore_ParamsDataView {
 public:
  NetworkEasterEgg_UpdateHighScore_ParamsDataView() {}

  NetworkEasterEgg_UpdateHighScore_ParamsDataView(
      internal::NetworkEasterEgg_UpdateHighScore_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t high_score() const {
    return data_->high_score;
  }
 private:
  internal::NetworkEasterEgg_UpdateHighScore_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace chrome

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace chrome {
namespace mojom {








}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_NETWORK_EASTER_EGG_MOJOM_SHARED_H_
