// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_INTERNAL_H_
#define CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace chrome {
namespace mojom {
namespace internal {

struct OfflinePageAutoFetcherScheduleResult_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  OfflinePageAutoFetcher_TrySchedule_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OfflinePageAutoFetcher_TrySchedule_Params_Data));
      new (data()) OfflinePageAutoFetcher_TrySchedule_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OfflinePageAutoFetcher_TrySchedule_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OfflinePageAutoFetcher_TrySchedule_Params_Data>(index_);
    }
    OfflinePageAutoFetcher_TrySchedule_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t user_requested : 1;
  uint8_t padfinal_[7];

 private:
  OfflinePageAutoFetcher_TrySchedule_Params_Data();
  ~OfflinePageAutoFetcher_TrySchedule_Params_Data() = delete;
};
static_assert(sizeof(OfflinePageAutoFetcher_TrySchedule_Params_Data) == 16,
              "Bad sizeof(OfflinePageAutoFetcher_TrySchedule_Params_Data)");
class  OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data));
      new (data()) OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data>(index_);
    }
    OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t out;
  uint8_t padfinal_[4];

 private:
  OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data();
  ~OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data() = delete;
};
static_assert(sizeof(OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data) == 16,
              "Bad sizeof(OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data)");
class  OfflinePageAutoFetcher_CancelSchedule_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OfflinePageAutoFetcher_CancelSchedule_Params_Data));
      new (data()) OfflinePageAutoFetcher_CancelSchedule_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OfflinePageAutoFetcher_CancelSchedule_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OfflinePageAutoFetcher_CancelSchedule_Params_Data>(index_);
    }
    OfflinePageAutoFetcher_CancelSchedule_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  OfflinePageAutoFetcher_CancelSchedule_Params_Data();
  ~OfflinePageAutoFetcher_CancelSchedule_Params_Data() = delete;
};
static_assert(sizeof(OfflinePageAutoFetcher_CancelSchedule_Params_Data) == 8,
              "Bad sizeof(OfflinePageAutoFetcher_CancelSchedule_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_INTERNAL_H_