// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_H_
#define CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "chrome/common/offline_page_auto_fetcher.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace chrome {
namespace mojom {


}  // namespace mojom
}  // namespace chrome

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace chrome {
namespace mojom {

enum class OfflinePageAutoFetcherScheduleResult : int32_t {
  kNotEnoughQuota,
  kOtherError,
  kAlreadyScheduled,
  kScheduled,
  kMinValue = 0,
  kMaxValue = 3,
};

inline std::ostream& operator<<(std::ostream& os, OfflinePageAutoFetcherScheduleResult value) {
  switch(value) {
    case OfflinePageAutoFetcherScheduleResult::kNotEnoughQuota:
      return os << "OfflinePageAutoFetcherScheduleResult::kNotEnoughQuota";
    case OfflinePageAutoFetcherScheduleResult::kOtherError:
      return os << "OfflinePageAutoFetcherScheduleResult::kOtherError";
    case OfflinePageAutoFetcherScheduleResult::kAlreadyScheduled:
      return os << "OfflinePageAutoFetcherScheduleResult::kAlreadyScheduled";
    case OfflinePageAutoFetcherScheduleResult::kScheduled:
      return os << "OfflinePageAutoFetcherScheduleResult::kScheduled";
    default:
      return os << "Unknown OfflinePageAutoFetcherScheduleResult value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(OfflinePageAutoFetcherScheduleResult value) {
  return internal::OfflinePageAutoFetcherScheduleResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class OfflinePageAutoFetcherInterfaceBase {};

using OfflinePageAutoFetcherPtrDataView =
    mojo::InterfacePtrDataView<OfflinePageAutoFetcherInterfaceBase>;
using OfflinePageAutoFetcherRequestDataView =
    mojo::InterfaceRequestDataView<OfflinePageAutoFetcherInterfaceBase>;
using OfflinePageAutoFetcherAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<OfflinePageAutoFetcherInterfaceBase>;
using OfflinePageAutoFetcherAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<OfflinePageAutoFetcherInterfaceBase>;
class OfflinePageAutoFetcher_TrySchedule_ParamsDataView {
 public:
  OfflinePageAutoFetcher_TrySchedule_ParamsDataView() {}

  OfflinePageAutoFetcher_TrySchedule_ParamsDataView(
      internal::OfflinePageAutoFetcher_TrySchedule_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool user_requested() const {
    return data_->user_requested;
  }
 private:
  internal::OfflinePageAutoFetcher_TrySchedule_Params_Data* data_ = nullptr;
};

class OfflinePageAutoFetcher_TrySchedule_ResponseParamsDataView {
 public:
  OfflinePageAutoFetcher_TrySchedule_ResponseParamsDataView() {}

  OfflinePageAutoFetcher_TrySchedule_ResponseParamsDataView(
      internal::OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOut(UserType* output) const {
    auto data_value = data_->out;
    return mojo::internal::Deserialize<::chrome::mojom::OfflinePageAutoFetcherScheduleResult>(
        data_value, output);
  }

  OfflinePageAutoFetcherScheduleResult out() const {
    return static_cast<OfflinePageAutoFetcherScheduleResult>(data_->out);
  }
 private:
  internal::OfflinePageAutoFetcher_TrySchedule_ResponseParams_Data* data_ = nullptr;
};

class OfflinePageAutoFetcher_CancelSchedule_ParamsDataView {
 public:
  OfflinePageAutoFetcher_CancelSchedule_ParamsDataView() {}

  OfflinePageAutoFetcher_CancelSchedule_ParamsDataView(
      internal::OfflinePageAutoFetcher_CancelSchedule_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::OfflinePageAutoFetcher_CancelSchedule_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace chrome

namespace std {

template <>
struct hash<::chrome::mojom::OfflinePageAutoFetcherScheduleResult>
    : public mojo::internal::EnumHashImpl<::chrome::mojom::OfflinePageAutoFetcherScheduleResult> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::chrome::mojom::OfflinePageAutoFetcherScheduleResult, ::chrome::mojom::OfflinePageAutoFetcherScheduleResult> {
  static ::chrome::mojom::OfflinePageAutoFetcherScheduleResult ToMojom(::chrome::mojom::OfflinePageAutoFetcherScheduleResult input) { return input; }
  static bool FromMojom(::chrome::mojom::OfflinePageAutoFetcherScheduleResult input, ::chrome::mojom::OfflinePageAutoFetcherScheduleResult* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::chrome::mojom::OfflinePageAutoFetcherScheduleResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::chrome::mojom::OfflinePageAutoFetcherScheduleResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::chrome::mojom::OfflinePageAutoFetcherScheduleResult>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace chrome {
namespace mojom {








}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_OFFLINE_PAGE_AUTO_FETCHER_MOJOM_SHARED_H_
