// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_SHARED_INTERNAL_H_
#define CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "components/content_settings/core/common/content_settings.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace chrome {
namespace mojom {
namespace internal {
class DynamicParams_Data;

#pragma pack(push, 1)
class  DynamicParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DynamicParams_Data));
      new (data()) DynamicParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DynamicParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DynamicParams_Data>(index_);
    }
    DynamicParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t force_safe_search : 1;
  uint8_t pad0_[3];
  int32_t youtube_restrict;
  mojo::internal::Pointer<mojo::internal::String_Data> allowed_domains_for_apps;
  mojo::internal::Pointer<mojo::internal::String_Data> variation_ids_header;

 private:
  DynamicParams_Data();
  ~DynamicParams_Data() = delete;
};
static_assert(sizeof(DynamicParams_Data) == 32,
              "Bad sizeof(DynamicParams_Data)");
// Used by DynamicParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct DynamicParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  DynamicParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~DynamicParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    DynamicParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    DynamicParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  RendererConfiguration_SetInitialConfiguration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data));
      new (data()) RendererConfiguration_SetInitialConfiguration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetInitialConfiguration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetInitialConfiguration_Params_Data>(index_);
    }
    RendererConfiguration_SetInitialConfiguration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_incognito_process : 1;
  uint8_t padfinal_[7];

 private:
  RendererConfiguration_SetInitialConfiguration_Params_Data();
  ~RendererConfiguration_SetInitialConfiguration_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data)");
class  RendererConfiguration_SetConfiguration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetConfiguration_Params_Data));
      new (data()) RendererConfiguration_SetConfiguration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetConfiguration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetConfiguration_Params_Data>(index_);
    }
    RendererConfiguration_SetConfiguration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::DynamicParams_Data> params;

 private:
  RendererConfiguration_SetConfiguration_Params_Data();
  ~RendererConfiguration_SetConfiguration_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetConfiguration_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetConfiguration_Params_Data)");
class  RendererConfiguration_SetContentSettingRules_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetContentSettingRules_Params_Data));
      new (data()) RendererConfiguration_SetContentSettingRules_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetContentSettingRules_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetContentSettingRules_Params_Data>(index_);
    }
    RendererConfiguration_SetContentSettingRules_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::content_settings::mojom::internal::RendererContentSettingRules_Data> rules;

 private:
  RendererConfiguration_SetContentSettingRules_Params_Data();
  ~RendererConfiguration_SetContentSettingRules_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetContentSettingRules_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetContentSettingRules_Params_Data)");
class  RendererConfiguration_SetFieldTrialGroup_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data));
      new (data()) RendererConfiguration_SetFieldTrialGroup_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetFieldTrialGroup_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetFieldTrialGroup_Params_Data>(index_);
    }
    RendererConfiguration_SetFieldTrialGroup_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> trial_name;
  mojo::internal::Pointer<mojo::internal::String_Data> group_name;

 private:
  RendererConfiguration_SetFieldTrialGroup_Params_Data();
  ~RendererConfiguration_SetFieldTrialGroup_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data) == 24,
              "Bad sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_SHARED_INTERNAL_H_