// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "chrome/services/app_service/public/mojom/types.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace apps {
namespace mojom {
namespace internal {
class ConnectOptions_Data;

#pragma pack(push, 1)
class  ConnectOptions_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConnectOptions_Data));
      new (data()) ConnectOptions_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConnectOptions_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConnectOptions_Data>(index_);
    }
    ConnectOptions_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ConnectOptions_Data();
  ~ConnectOptions_Data() = delete;
};
static_assert(sizeof(ConnectOptions_Data) == 8,
              "Bad sizeof(ConnectOptions_Data)");
// Used by ConnectOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct ConnectOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  ConnectOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~ConnectOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    ConnectOptions_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    ConnectOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  AppService_RegisterPublisher_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AppService_RegisterPublisher_Params_Data));
      new (data()) AppService_RegisterPublisher_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AppService_RegisterPublisher_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AppService_RegisterPublisher_Params_Data>(index_);
    }
    AppService_RegisterPublisher_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data publisher;
  int32_t app_type;
  uint8_t padfinal_[4];

 private:
  AppService_RegisterPublisher_Params_Data();
  ~AppService_RegisterPublisher_Params_Data() = delete;
};
static_assert(sizeof(AppService_RegisterPublisher_Params_Data) == 24,
              "Bad sizeof(AppService_RegisterPublisher_Params_Data)");
class  AppService_RegisterSubscriber_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AppService_RegisterSubscriber_Params_Data));
      new (data()) AppService_RegisterSubscriber_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AppService_RegisterSubscriber_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AppService_RegisterSubscriber_Params_Data>(index_);
    }
    AppService_RegisterSubscriber_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data subscriber;
  mojo::internal::Pointer<internal::ConnectOptions_Data> opts;

 private:
  AppService_RegisterSubscriber_Params_Data();
  ~AppService_RegisterSubscriber_Params_Data() = delete;
};
static_assert(sizeof(AppService_RegisterSubscriber_Params_Data) == 24,
              "Bad sizeof(AppService_RegisterSubscriber_Params_Data)");
class  AppService_LoadIcon_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AppService_LoadIcon_Params_Data));
      new (data()) AppService_LoadIcon_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AppService_LoadIcon_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AppService_LoadIcon_Params_Data>(index_);
    }
    AppService_LoadIcon_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t app_type;
  int32_t icon_compression;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;
  mojo::internal::Pointer<::apps::mojom::internal::IconKey_Data> icon_key;
  int32_t size_hint_in_dip;
  uint8_t padfinal_[4];

 private:
  AppService_LoadIcon_Params_Data();
  ~AppService_LoadIcon_Params_Data() = delete;
};
static_assert(sizeof(AppService_LoadIcon_Params_Data) == 40,
              "Bad sizeof(AppService_LoadIcon_Params_Data)");
class  AppService_LoadIcon_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AppService_LoadIcon_ResponseParams_Data));
      new (data()) AppService_LoadIcon_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AppService_LoadIcon_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AppService_LoadIcon_ResponseParams_Data>(index_);
    }
    AppService_LoadIcon_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::apps::mojom::internal::IconValue_Data> icon_value;

 private:
  AppService_LoadIcon_ResponseParams_Data();
  ~AppService_LoadIcon_ResponseParams_Data() = delete;
};
static_assert(sizeof(AppService_LoadIcon_ResponseParams_Data) == 16,
              "Bad sizeof(AppService_LoadIcon_ResponseParams_Data)");
class  AppService_Launch_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AppService_Launch_Params_Data));
      new (data()) AppService_Launch_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AppService_Launch_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AppService_Launch_Params_Data>(index_);
    }
    AppService_Launch_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t app_type;
  int32_t event_flags;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;

 private:
  AppService_Launch_Params_Data();
  ~AppService_Launch_Params_Data() = delete;
};
static_assert(sizeof(AppService_Launch_Params_Data) == 24,
              "Bad sizeof(AppService_Launch_Params_Data)");
class  Publisher_Connect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Publisher_Connect_Params_Data));
      new (data()) Publisher_Connect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Publisher_Connect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Publisher_Connect_Params_Data>(index_);
    }
    Publisher_Connect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data subscriber;
  mojo::internal::Pointer<internal::ConnectOptions_Data> opts;

 private:
  Publisher_Connect_Params_Data();
  ~Publisher_Connect_Params_Data() = delete;
};
static_assert(sizeof(Publisher_Connect_Params_Data) == 24,
              "Bad sizeof(Publisher_Connect_Params_Data)");
class  Publisher_LoadIcon_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Publisher_LoadIcon_Params_Data));
      new (data()) Publisher_LoadIcon_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Publisher_LoadIcon_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Publisher_LoadIcon_Params_Data>(index_);
    }
    Publisher_LoadIcon_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;
  mojo::internal::Pointer<::apps::mojom::internal::IconKey_Data> icon_key;
  int32_t icon_compression;
  int32_t size_hint_in_dip;

 private:
  Publisher_LoadIcon_Params_Data();
  ~Publisher_LoadIcon_Params_Data() = delete;
};
static_assert(sizeof(Publisher_LoadIcon_Params_Data) == 32,
              "Bad sizeof(Publisher_LoadIcon_Params_Data)");
class  Publisher_LoadIcon_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Publisher_LoadIcon_ResponseParams_Data));
      new (data()) Publisher_LoadIcon_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Publisher_LoadIcon_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Publisher_LoadIcon_ResponseParams_Data>(index_);
    }
    Publisher_LoadIcon_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::apps::mojom::internal::IconValue_Data> icon_value;

 private:
  Publisher_LoadIcon_ResponseParams_Data();
  ~Publisher_LoadIcon_ResponseParams_Data() = delete;
};
static_assert(sizeof(Publisher_LoadIcon_ResponseParams_Data) == 16,
              "Bad sizeof(Publisher_LoadIcon_ResponseParams_Data)");
class  Publisher_Launch_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Publisher_Launch_Params_Data));
      new (data()) Publisher_Launch_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Publisher_Launch_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Publisher_Launch_Params_Data>(index_);
    }
    Publisher_Launch_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> app_id;
  int32_t event_flags;
  uint8_t padfinal_[4];

 private:
  Publisher_Launch_Params_Data();
  ~Publisher_Launch_Params_Data() = delete;
};
static_assert(sizeof(Publisher_Launch_Params_Data) == 24,
              "Bad sizeof(Publisher_Launch_Params_Data)");
class  Subscriber_OnApps_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Subscriber_OnApps_Params_Data));
      new (data()) Subscriber_OnApps_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Subscriber_OnApps_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Subscriber_OnApps_Params_Data>(index_);
    }
    Subscriber_OnApps_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::apps::mojom::internal::App_Data>>> deltas;

 private:
  Subscriber_OnApps_Params_Data();
  ~Subscriber_OnApps_Params_Data() = delete;
};
static_assert(sizeof(Subscriber_OnApps_Params_Data) == 16,
              "Bad sizeof(Subscriber_OnApps_Params_Data)");
class  Subscriber_Clone_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(Subscriber_Clone_Params_Data));
      new (data()) Subscriber_Clone_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    Subscriber_Clone_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<Subscriber_Clone_Params_Data>(index_);
    }
    Subscriber_Clone_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  Subscriber_Clone_Params_Data();
  ~Subscriber_Clone_Params_Data() = delete;
};
static_assert(sizeof(Subscriber_Clone_Params_Data) == 16,
              "Bad sizeof(Subscriber_Clone_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace apps

#endif  // CHROME_SERVICES_APP_SERVICE_PUBLIC_MOJOM_APP_SERVICE_MOJOM_SHARED_INTERNAL_H_