// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_AUTOFILL_CONTENT_COMMON_AUTOFILL_AGENT_MOJOM_SHARED_H_
#define COMPONENTS_AUTOFILL_CONTENT_COMMON_AUTOFILL_AGENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "components/autofill/content/common/autofill_agent.mojom-shared-internal.h"
#include "components/autofill/content/common/autofill_types.mojom-shared.h"
#include "mojo/public/mojom/base/string16.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace autofill {
namespace mojom {


}  // namespace mojom
}  // namespace autofill

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace autofill {
namespace mojom {
// Interface base classes. They are used for type safety check.
class AutofillAgentInterfaceBase {};

using AutofillAgentPtrDataView =
    mojo::InterfacePtrDataView<AutofillAgentInterfaceBase>;
using AutofillAgentRequestDataView =
    mojo::InterfaceRequestDataView<AutofillAgentInterfaceBase>;
using AutofillAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AutofillAgentInterfaceBase>;
using AutofillAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AutofillAgentInterfaceBase>;
class PasswordAutofillAgentInterfaceBase {};

using PasswordAutofillAgentPtrDataView =
    mojo::InterfacePtrDataView<PasswordAutofillAgentInterfaceBase>;
using PasswordAutofillAgentRequestDataView =
    mojo::InterfaceRequestDataView<PasswordAutofillAgentInterfaceBase>;
using PasswordAutofillAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PasswordAutofillAgentInterfaceBase>;
using PasswordAutofillAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PasswordAutofillAgentInterfaceBase>;
class PasswordGenerationAgentInterfaceBase {};

using PasswordGenerationAgentPtrDataView =
    mojo::InterfacePtrDataView<PasswordGenerationAgentInterfaceBase>;
using PasswordGenerationAgentRequestDataView =
    mojo::InterfaceRequestDataView<PasswordGenerationAgentInterfaceBase>;
using PasswordGenerationAgentAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PasswordGenerationAgentInterfaceBase>;
using PasswordGenerationAgentAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PasswordGenerationAgentInterfaceBase>;
class AutofillAgent_FillForm_ParamsDataView {
 public:
  AutofillAgent_FillForm_ParamsDataView() {}

  AutofillAgent_FillForm_ParamsDataView(
      internal::AutofillAgent_FillForm_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t id() const {
    return data_->id;
  }
  inline void GetFormDataView(
      ::autofill::mojom::FormDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForm(UserType* output) {
    auto* pointer = data_->form.Get();
    return mojo::internal::Deserialize<::autofill::mojom::FormDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_FillForm_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_PreviewForm_ParamsDataView {
 public:
  AutofillAgent_PreviewForm_ParamsDataView() {}

  AutofillAgent_PreviewForm_ParamsDataView(
      internal::AutofillAgent_PreviewForm_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t id() const {
    return data_->id;
  }
  inline void GetFormDataView(
      ::autofill::mojom::FormDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForm(UserType* output) {
    auto* pointer = data_->form.Get();
    return mojo::internal::Deserialize<::autofill::mojom::FormDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_PreviewForm_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_FieldTypePredictionsAvailable_ParamsDataView {
 public:
  AutofillAgent_FieldTypePredictionsAvailable_ParamsDataView() {}

  AutofillAgent_FieldTypePredictionsAvailable_ParamsDataView(
      internal::AutofillAgent_FieldTypePredictionsAvailable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormsDataView(
      mojo::ArrayDataView<::autofill::mojom::FormDataPredictionsDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForms(UserType* output) {
    auto* pointer = data_->forms.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::autofill::mojom::FormDataPredictionsDataView>>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_FieldTypePredictionsAvailable_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_ClearSection_ParamsDataView {
 public:
  AutofillAgent_ClearSection_ParamsDataView() {}

  AutofillAgent_ClearSection_ParamsDataView(
      internal::AutofillAgent_ClearSection_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::AutofillAgent_ClearSection_Params_Data* data_ = nullptr;
};

class AutofillAgent_ClearPreviewedForm_ParamsDataView {
 public:
  AutofillAgent_ClearPreviewedForm_ParamsDataView() {}

  AutofillAgent_ClearPreviewedForm_ParamsDataView(
      internal::AutofillAgent_ClearPreviewedForm_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::AutofillAgent_ClearPreviewedForm_Params_Data* data_ = nullptr;
};

class AutofillAgent_FillFieldWithValue_ParamsDataView {
 public:
  AutofillAgent_FillFieldWithValue_ParamsDataView() {}

  AutofillAgent_FillFieldWithValue_ParamsDataView(
      internal::AutofillAgent_FillFieldWithValue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_FillFieldWithValue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_PreviewFieldWithValue_ParamsDataView {
 public:
  AutofillAgent_PreviewFieldWithValue_ParamsDataView() {}

  AutofillAgent_PreviewFieldWithValue_ParamsDataView(
      internal::AutofillAgent_PreviewFieldWithValue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_PreviewFieldWithValue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_AcceptDataListSuggestion_ParamsDataView {
 public:
  AutofillAgent_AcceptDataListSuggestion_ParamsDataView() {}

  AutofillAgent_AcceptDataListSuggestion_ParamsDataView(
      internal::AutofillAgent_AcceptDataListSuggestion_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetValueDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadValue(UserType* output) {
    auto* pointer = data_->value.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_AcceptDataListSuggestion_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_FillPasswordSuggestion_ParamsDataView {
 public:
  AutofillAgent_FillPasswordSuggestion_ParamsDataView() {}

  AutofillAgent_FillPasswordSuggestion_ParamsDataView(
      internal::AutofillAgent_FillPasswordSuggestion_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUsernameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUsername(UserType* output) {
    auto* pointer = data_->username.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetPasswordDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPassword(UserType* output) {
    auto* pointer = data_->password.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_FillPasswordSuggestion_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_PreviewPasswordSuggestion_ParamsDataView {
 public:
  AutofillAgent_PreviewPasswordSuggestion_ParamsDataView() {}

  AutofillAgent_PreviewPasswordSuggestion_ParamsDataView(
      internal::AutofillAgent_PreviewPasswordSuggestion_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUsernameDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUsername(UserType* output) {
    auto* pointer = data_->username.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
  inline void GetPasswordDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPassword(UserType* output) {
    auto* pointer = data_->password.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_PreviewPasswordSuggestion_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_ShowInitialPasswordAccountSuggestions_ParamsDataView {
 public:
  AutofillAgent_ShowInitialPasswordAccountSuggestions_ParamsDataView() {}

  AutofillAgent_ShowInitialPasswordAccountSuggestions_ParamsDataView(
      internal::AutofillAgent_ShowInitialPasswordAccountSuggestions_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormDataDataView(
      ::autofill::mojom::PasswordFormFillDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFormData(UserType* output) {
    auto* pointer = data_->form_data.Get();
    return mojo::internal::Deserialize<::autofill::mojom::PasswordFormFillDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_ShowInitialPasswordAccountSuggestions_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_SetUserGestureRequired_ParamsDataView {
 public:
  AutofillAgent_SetUserGestureRequired_ParamsDataView() {}

  AutofillAgent_SetUserGestureRequired_ParamsDataView(
      internal::AutofillAgent_SetUserGestureRequired_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool required() const {
    return data_->required;
  }
 private:
  internal::AutofillAgent_SetUserGestureRequired_Params_Data* data_ = nullptr;
};

class AutofillAgent_SetSecureContextRequired_ParamsDataView {
 public:
  AutofillAgent_SetSecureContextRequired_ParamsDataView() {}

  AutofillAgent_SetSecureContextRequired_ParamsDataView(
      internal::AutofillAgent_SetSecureContextRequired_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool required() const {
    return data_->required;
  }
 private:
  internal::AutofillAgent_SetSecureContextRequired_Params_Data* data_ = nullptr;
};

class AutofillAgent_SetFocusRequiresScroll_ParamsDataView {
 public:
  AutofillAgent_SetFocusRequiresScroll_ParamsDataView() {}

  AutofillAgent_SetFocusRequiresScroll_ParamsDataView(
      internal::AutofillAgent_SetFocusRequiresScroll_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool require() const {
    return data_->require;
  }
 private:
  internal::AutofillAgent_SetFocusRequiresScroll_Params_Data* data_ = nullptr;
};

class AutofillAgent_SetQueryPasswordSuggestion_ParamsDataView {
 public:
  AutofillAgent_SetQueryPasswordSuggestion_ParamsDataView() {}

  AutofillAgent_SetQueryPasswordSuggestion_ParamsDataView(
      internal::AutofillAgent_SetQueryPasswordSuggestion_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool query() const {
    return data_->query;
  }
 private:
  internal::AutofillAgent_SetQueryPasswordSuggestion_Params_Data* data_ = nullptr;
};

class AutofillAgent_GetElementFormAndFieldData_ParamsDataView {
 public:
  AutofillAgent_GetElementFormAndFieldData_ParamsDataView() {}

  AutofillAgent_GetElementFormAndFieldData_ParamsDataView(
      internal::AutofillAgent_GetElementFormAndFieldData_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetSelectorsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSelectors(UserType* output) {
    auto* pointer = data_->selectors.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_GetElementFormAndFieldData_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AutofillAgent_GetElementFormAndFieldData_ResponseParamsDataView {
 public:
  AutofillAgent_GetElementFormAndFieldData_ResponseParamsDataView() {}

  AutofillAgent_GetElementFormAndFieldData_ResponseParamsDataView(
      internal::AutofillAgent_GetElementFormAndFieldData_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormDataView(
      ::autofill::mojom::FormDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForm(UserType* output) {
    auto* pointer = data_->form.Get();
    return mojo::internal::Deserialize<::autofill::mojom::FormDataDataView>(
        pointer, output, context_);
  }
  inline void GetFieldDataView(
      ::autofill::mojom::FormFieldDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadField(UserType* output) {
    auto* pointer = data_->field.Get();
    return mojo::internal::Deserialize<::autofill::mojom::FormFieldDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AutofillAgent_GetElementFormAndFieldData_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordAutofillAgent_FillPasswordForm_ParamsDataView {
 public:
  PasswordAutofillAgent_FillPasswordForm_ParamsDataView() {}

  PasswordAutofillAgent_FillPasswordForm_ParamsDataView(
      internal::PasswordAutofillAgent_FillPasswordForm_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormDataDataView(
      ::autofill::mojom::PasswordFormFillDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFormData(UserType* output) {
    auto* pointer = data_->form_data.Get();
    return mojo::internal::Deserialize<::autofill::mojom::PasswordFormFillDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::PasswordAutofillAgent_FillPasswordForm_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordAutofillAgent_FillIntoFocusedField_ParamsDataView {
 public:
  PasswordAutofillAgent_FillIntoFocusedField_ParamsDataView() {}

  PasswordAutofillAgent_FillIntoFocusedField_ParamsDataView(
      internal::PasswordAutofillAgent_FillIntoFocusedField_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool is_password() const {
    return data_->is_password;
  }
  inline void GetCredentialDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCredential(UserType* output) {
    auto* pointer = data_->credential.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::PasswordAutofillAgent_FillIntoFocusedField_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordAutofillAgent_FillIntoFocusedField_ResponseParamsDataView {
 public:
  PasswordAutofillAgent_FillIntoFocusedField_ResponseParamsDataView() {}

  PasswordAutofillAgent_FillIntoFocusedField_ResponseParamsDataView(
      internal::PasswordAutofillAgent_FillIntoFocusedField_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) const {
    auto data_value = data_->status;
    return mojo::internal::Deserialize<::autofill::mojom::FillingStatus>(
        data_value, output);
  }

  ::autofill::mojom::FillingStatus status() const {
    return static_cast<::autofill::mojom::FillingStatus>(data_->status);
  }
 private:
  internal::PasswordAutofillAgent_FillIntoFocusedField_ResponseParams_Data* data_ = nullptr;
};

class PasswordAutofillAgent_SetLoggingState_ParamsDataView {
 public:
  PasswordAutofillAgent_SetLoggingState_ParamsDataView() {}

  PasswordAutofillAgent_SetLoggingState_ParamsDataView(
      internal::PasswordAutofillAgent_SetLoggingState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool active() const {
    return data_->active;
  }
 private:
  internal::PasswordAutofillAgent_SetLoggingState_Params_Data* data_ = nullptr;
};

class PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_ParamsDataView {
 public:
  PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_ParamsDataView() {}

  PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_ParamsDataView(
      internal::PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPredictionsDataView(
      ::autofill::mojom::FormsPredictionsMapDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPredictions(UserType* output) {
    auto* pointer = data_->predictions.Get();
    return mojo::internal::Deserialize<::autofill::mojom::FormsPredictionsMapDataView>(
        pointer, output, context_);
  }
 private:
  internal::PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordGenerationAgent_GeneratedPasswordAccepted_ParamsDataView {
 public:
  PasswordGenerationAgent_GeneratedPasswordAccepted_ParamsDataView() {}

  PasswordGenerationAgent_GeneratedPasswordAccepted_ParamsDataView(
      internal::PasswordGenerationAgent_GeneratedPasswordAccepted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetGeneratedPasswordDataView(
      ::mojo_base::mojom::String16DataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGeneratedPassword(UserType* output) {
    auto* pointer = data_->generated_password.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::String16DataView>(
        pointer, output, context_);
  }
 private:
  internal::PasswordGenerationAgent_GeneratedPasswordAccepted_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordGenerationAgent_UserTriggeredGeneratePassword_ParamsDataView {
 public:
  PasswordGenerationAgent_UserTriggeredGeneratePassword_ParamsDataView() {}

  PasswordGenerationAgent_UserTriggeredGeneratePassword_ParamsDataView(
      internal::PasswordGenerationAgent_UserTriggeredGeneratePassword_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PasswordGenerationAgent_UserTriggeredGeneratePassword_Params_Data* data_ = nullptr;
};

class PasswordGenerationAgent_FormNotBlacklisted_ParamsDataView {
 public:
  PasswordGenerationAgent_FormNotBlacklisted_ParamsDataView() {}

  PasswordGenerationAgent_FormNotBlacklisted_ParamsDataView(
      internal::PasswordGenerationAgent_FormNotBlacklisted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormDataView(
      ::autofill::mojom::PasswordFormDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForm(UserType* output) {
    auto* pointer = data_->form.Get();
    return mojo::internal::Deserialize<::autofill::mojom::PasswordFormDataView>(
        pointer, output, context_);
  }
 private:
  internal::PasswordGenerationAgent_FormNotBlacklisted_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PasswordGenerationAgent_FoundFormsEligibleForGeneration_ParamsDataView {
 public:
  PasswordGenerationAgent_FoundFormsEligibleForGeneration_ParamsDataView() {}

  PasswordGenerationAgent_FoundFormsEligibleForGeneration_ParamsDataView(
      internal::PasswordGenerationAgent_FoundFormsEligibleForGeneration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFormsDataView(
      mojo::ArrayDataView<::autofill::mojom::PasswordFormGenerationDataDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadForms(UserType* output) {
    auto* pointer = data_->forms.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::autofill::mojom::PasswordFormGenerationDataDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PasswordGenerationAgent_FoundFormsEligibleForGeneration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace autofill

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace autofill {
namespace mojom {

inline void AutofillAgent_FillForm_ParamsDataView::GetFormDataView(
    ::autofill::mojom::FormDataDataView* output) {
  auto pointer = data_->form.Get();
  *output = ::autofill::mojom::FormDataDataView(pointer, context_);
}


inline void AutofillAgent_PreviewForm_ParamsDataView::GetFormDataView(
    ::autofill::mojom::FormDataDataView* output) {
  auto pointer = data_->form.Get();
  *output = ::autofill::mojom::FormDataDataView(pointer, context_);
}


inline void AutofillAgent_FieldTypePredictionsAvailable_ParamsDataView::GetFormsDataView(
    mojo::ArrayDataView<::autofill::mojom::FormDataPredictionsDataView>* output) {
  auto pointer = data_->forms.Get();
  *output = mojo::ArrayDataView<::autofill::mojom::FormDataPredictionsDataView>(pointer, context_);
}






inline void AutofillAgent_FillFieldWithValue_ParamsDataView::GetValueDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->value.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void AutofillAgent_PreviewFieldWithValue_ParamsDataView::GetValueDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->value.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void AutofillAgent_AcceptDataListSuggestion_ParamsDataView::GetValueDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->value.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void AutofillAgent_FillPasswordSuggestion_ParamsDataView::GetUsernameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->username.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void AutofillAgent_FillPasswordSuggestion_ParamsDataView::GetPasswordDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->password.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void AutofillAgent_PreviewPasswordSuggestion_ParamsDataView::GetUsernameDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->username.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}
inline void AutofillAgent_PreviewPasswordSuggestion_ParamsDataView::GetPasswordDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->password.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}


inline void AutofillAgent_ShowInitialPasswordAccountSuggestions_ParamsDataView::GetFormDataDataView(
    ::autofill::mojom::PasswordFormFillDataDataView* output) {
  auto pointer = data_->form_data.Get();
  *output = ::autofill::mojom::PasswordFormFillDataDataView(pointer, context_);
}










inline void AutofillAgent_GetElementFormAndFieldData_ParamsDataView::GetSelectorsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->selectors.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}


inline void AutofillAgent_GetElementFormAndFieldData_ResponseParamsDataView::GetFormDataView(
    ::autofill::mojom::FormDataDataView* output) {
  auto pointer = data_->form.Get();
  *output = ::autofill::mojom::FormDataDataView(pointer, context_);
}
inline void AutofillAgent_GetElementFormAndFieldData_ResponseParamsDataView::GetFieldDataView(
    ::autofill::mojom::FormFieldDataDataView* output) {
  auto pointer = data_->field.Get();
  *output = ::autofill::mojom::FormFieldDataDataView(pointer, context_);
}


inline void PasswordAutofillAgent_FillPasswordForm_ParamsDataView::GetFormDataDataView(
    ::autofill::mojom::PasswordFormFillDataDataView* output) {
  auto pointer = data_->form_data.Get();
  *output = ::autofill::mojom::PasswordFormFillDataDataView(pointer, context_);
}


inline void PasswordAutofillAgent_FillIntoFocusedField_ParamsDataView::GetCredentialDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->credential.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}






inline void PasswordAutofillAgent_AutofillUsernameAndPasswordDataReceived_ParamsDataView::GetPredictionsDataView(
    ::autofill::mojom::FormsPredictionsMapDataView* output) {
  auto pointer = data_->predictions.Get();
  *output = ::autofill::mojom::FormsPredictionsMapDataView(pointer, context_);
}


inline void PasswordGenerationAgent_GeneratedPasswordAccepted_ParamsDataView::GetGeneratedPasswordDataView(
    ::mojo_base::mojom::String16DataView* output) {
  auto pointer = data_->generated_password.Get();
  *output = ::mojo_base::mojom::String16DataView(pointer, context_);
}




inline void PasswordGenerationAgent_FormNotBlacklisted_ParamsDataView::GetFormDataView(
    ::autofill::mojom::PasswordFormDataView* output) {
  auto pointer = data_->form.Get();
  *output = ::autofill::mojom::PasswordFormDataView(pointer, context_);
}


inline void PasswordGenerationAgent_FoundFormsEligibleForGeneration_ParamsDataView::GetFormsDataView(
    mojo::ArrayDataView<::autofill::mojom::PasswordFormGenerationDataDataView>* output) {
  auto pointer = data_->forms.Get();
  *output = mojo::ArrayDataView<::autofill::mojom::PasswordFormGenerationDataDataView>(pointer, context_);
}



}  // namespace mojom
}  // namespace autofill

#endif  // COMPONENTS_AUTOFILL_CONTENT_COMMON_AUTOFILL_AGENT_MOJOM_SHARED_H_
