// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "components/mirroring/mojom/cast_message_channel.mojom-shared-internal.h"
#include "components/mirroring/mojom/resource_provider.mojom-shared-internal.h"
#include "components/mirroring/mojom/session_observer.mojom-shared-internal.h"
#include "components/mirroring/mojom/session_parameters.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace mirroring {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  MirroringService_Start_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MirroringService_Start_Params_Data));
      new (data()) MirroringService_Start_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MirroringService_Start_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MirroringService_Start_Params_Data>(index_);
    }
    MirroringService_Start_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mirroring::mojom::internal::SessionParameters_Data> params;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> max_resolution;
  mojo::internal::Interface_Data observer;
  mojo::internal::Interface_Data resource_provider;
  mojo::internal::Interface_Data outbound_channel;
  mojo::internal::Handle_Data inbound_channel;
  uint8_t padfinal_[4];

 private:
  MirroringService_Start_Params_Data();
  ~MirroringService_Start_Params_Data() = delete;
};
static_assert(sizeof(MirroringService_Start_Params_Data) == 56,
              "Bad sizeof(MirroringService_Start_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace mirroring

#endif  // COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_INTERNAL_H_