// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_H_
#define COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "components/mirroring/mojom/mirroring_service.mojom-shared-internal.h"
#include "components/mirroring/mojom/cast_message_channel.mojom-shared.h"
#include "components/mirroring/mojom/resource_provider.mojom-shared.h"
#include "components/mirroring/mojom/session_observer.mojom-shared.h"
#include "components/mirroring/mojom/session_parameters.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace mirroring {
namespace mojom {


}  // namespace mojom
}  // namespace mirroring

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace mirroring {
namespace mojom {
// Interface base classes. They are used for type safety check.
class MirroringServiceInterfaceBase {};

using MirroringServicePtrDataView =
    mojo::InterfacePtrDataView<MirroringServiceInterfaceBase>;
using MirroringServiceRequestDataView =
    mojo::InterfaceRequestDataView<MirroringServiceInterfaceBase>;
using MirroringServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<MirroringServiceInterfaceBase>;
using MirroringServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<MirroringServiceInterfaceBase>;
class MirroringService_Start_ParamsDataView {
 public:
  MirroringService_Start_ParamsDataView() {}

  MirroringService_Start_ParamsDataView(
      internal::MirroringService_Start_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetParamsDataView(
      ::mirroring::mojom::SessionParametersDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::mirroring::mojom::SessionParametersDataView>(
        pointer, output, context_);
  }
  inline void GetMaxResolutionDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMaxResolution(UserType* output) {
    auto* pointer = data_->max_resolution.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeObserver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::mirroring::mojom::SessionObserverPtrDataView>(
            &data_->observer, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeResourceProvider() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::mirroring::mojom::ResourceProviderPtrDataView>(
            &data_->resource_provider, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeOutboundChannel() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::mirroring::mojom::CastMessageChannelPtrDataView>(
            &data_->outbound_channel, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeInboundChannel() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::mirroring::mojom::CastMessageChannelRequestDataView>(
            &data_->inbound_channel, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::MirroringService_Start_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace mirroring

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace mirroring {
namespace mojom {

inline void MirroringService_Start_ParamsDataView::GetParamsDataView(
    ::mirroring::mojom::SessionParametersDataView* output) {
  auto pointer = data_->params.Get();
  *output = ::mirroring::mojom::SessionParametersDataView(pointer, context_);
}
inline void MirroringService_Start_ParamsDataView::GetMaxResolutionDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->max_resolution.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace mirroring

#endif  // COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_SHARED_H_
