// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "media/capture/mojom/video_capture.mojom-shared-internal.h"
#include "services/network/public/mojom/network_context.mojom-shared-internal.h"
#include "media/mojo/interfaces/remoting.mojom-shared-internal.h"
#include "media/mojo/interfaces/audio_data_pipe.mojom-shared-internal.h"
#include "media/mojo/interfaces/audio_input_stream.mojom-shared-internal.h"
#include "media/mojo/interfaces/audio_parameters.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace mirroring {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  AudioStreamCreatorClient_StreamCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AudioStreamCreatorClient_StreamCreated_Params_Data));
      new (data()) AudioStreamCreatorClient_StreamCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AudioStreamCreatorClient_StreamCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AudioStreamCreatorClient_StreamCreated_Params_Data>(index_);
    }
    AudioStreamCreatorClient_StreamCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data stream;
  mojo::internal::Handle_Data client_request;
  uint8_t initially_muted : 1;
  uint8_t pad2_[3];
  mojo::internal::Pointer<::media::mojom::internal::ReadOnlyAudioDataPipe_Data> data_pipe;

 private:
  AudioStreamCreatorClient_StreamCreated_Params_Data();
  ~AudioStreamCreatorClient_StreamCreated_Params_Data() = delete;
};
static_assert(sizeof(AudioStreamCreatorClient_StreamCreated_Params_Data) == 32,
              "Bad sizeof(AudioStreamCreatorClient_StreamCreated_Params_Data)");
class  ResourceProvider_GetVideoCaptureHost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResourceProvider_GetVideoCaptureHost_Params_Data));
      new (data()) ResourceProvider_GetVideoCaptureHost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResourceProvider_GetVideoCaptureHost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResourceProvider_GetVideoCaptureHost_Params_Data>(index_);
    }
    ResourceProvider_GetVideoCaptureHost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  ResourceProvider_GetVideoCaptureHost_Params_Data();
  ~ResourceProvider_GetVideoCaptureHost_Params_Data() = delete;
};
static_assert(sizeof(ResourceProvider_GetVideoCaptureHost_Params_Data) == 16,
              "Bad sizeof(ResourceProvider_GetVideoCaptureHost_Params_Data)");
class  ResourceProvider_GetNetworkContext_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResourceProvider_GetNetworkContext_Params_Data));
      new (data()) ResourceProvider_GetNetworkContext_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResourceProvider_GetNetworkContext_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResourceProvider_GetNetworkContext_Params_Data>(index_);
    }
    ResourceProvider_GetNetworkContext_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  ResourceProvider_GetNetworkContext_Params_Data();
  ~ResourceProvider_GetNetworkContext_Params_Data() = delete;
};
static_assert(sizeof(ResourceProvider_GetNetworkContext_Params_Data) == 16,
              "Bad sizeof(ResourceProvider_GetNetworkContext_Params_Data)");
class  ResourceProvider_CreateAudioStream_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResourceProvider_CreateAudioStream_Params_Data));
      new (data()) ResourceProvider_CreateAudioStream_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResourceProvider_CreateAudioStream_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResourceProvider_CreateAudioStream_Params_Data>(index_);
    }
    ResourceProvider_CreateAudioStream_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data client;
  mojo::internal::Pointer<::media::mojom::internal::AudioParameters_Data> param;
  uint32_t shared_memory_count;
  uint8_t padfinal_[4];

 private:
  ResourceProvider_CreateAudioStream_Params_Data();
  ~ResourceProvider_CreateAudioStream_Params_Data() = delete;
};
static_assert(sizeof(ResourceProvider_CreateAudioStream_Params_Data) == 32,
              "Bad sizeof(ResourceProvider_CreateAudioStream_Params_Data)");
class  ResourceProvider_ConnectToRemotingSource_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResourceProvider_ConnectToRemotingSource_Params_Data));
      new (data()) ResourceProvider_ConnectToRemotingSource_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResourceProvider_ConnectToRemotingSource_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResourceProvider_ConnectToRemotingSource_Params_Data>(index_);
    }
    ResourceProvider_ConnectToRemotingSource_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data remoter;
  mojo::internal::Handle_Data request;
  uint8_t padfinal_[4];

 private:
  ResourceProvider_ConnectToRemotingSource_Params_Data();
  ~ResourceProvider_ConnectToRemotingSource_Params_Data() = delete;
};
static_assert(sizeof(ResourceProvider_ConnectToRemotingSource_Params_Data) == 24,
              "Bad sizeof(ResourceProvider_ConnectToRemotingSource_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace mirroring

#endif  // COMPONENTS_MIRRORING_MOJOM_RESOURCE_PROVIDER_MOJOM_SHARED_INTERNAL_H_