//
// DO NOT MODIFY THIS FILE DIRECTLY!
// IT IS GENERATED BY generate_policy_source.py
// FROM ../../components/policy/resources/policy_templates.json
//

#include "components/policy/policy_constants.h"

#include <algorithm>
#include <climits>
#include <memory>

#include "base/logging.h"
#include "components/policy/core/common/policy_types.h"
#include "components/policy/core/common/schema_internal.h"
#include "components/policy/proto/cloud_policy.pb.h"
#include "components/policy/risk_tag.h"

namespace em = enterprise_management;


namespace policy {

const PolicyDetails kChromePolicyDetails[] = {
//  is_deprecated  is_device_policy  id    max_external_data_size
  // AbusiveExperienceInterventionEnforce
  { false,         false,           404,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AdsSettingForIntrusiveAdsSites
  { false,         false,           409,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowCrossOriginAuthPrompt
  { false,         false,            89,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AllowDeletingBrowserHistory
  { false,         false,           187,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_ADMIN_SHARING } },
  // AllowDinosaurEasterEgg
  { false,         false,           309,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowFileSelectionDialogs
  { false,         false,            84,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AllowOutdatedPlugins
  { false,         false,            81,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // AllowedDomainsForApps
  { false,         false,           331,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // AlternateErrorPagesEnabled
  { false,         false,             5,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AlternativeBrowserParameters
  { false,         false,           495,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AlternativeBrowserPath
  { false,         false,           494,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AlwaysOpenPdfExternally
  { false,         false,           347,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AudioCaptureAllowed
  { false,         false,           160,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AudioCaptureAllowedUrls
  { false,         false,           208,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AuthNegotiateDelegateWhitelist
  { false,         false,            30,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AuthSchemes
  { false,         false,            26,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AuthServerWhitelist
  { false,         false,            29,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoFillEnabled
  { true,          false,            18,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoSelectCertificateForUrls
  { false,         false,           102,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // AutofillAddressEnabled
  { false,         false,           459,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutofillCreditCardEnabled
  { false,         false,           392,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoplayAllowed
  { false,         false,           430,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // AutoplayWhitelist
  { false,         false,           431,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BackgroundModeEnabled
  { false,         false,           138,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // BlockThirdPartyCookies
  { false,         false,            39,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BookmarkBarEnabled
  { false,         false,            82,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserAddPersonEnabled
  { false,         false,           276,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserGuestModeEnabled
  { false,         false,           275,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserNetworkTimeQueriesEnabled
  { false,         false,           370,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserSignin
  { false,         false,           487,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserSwitcherUrlGreylist
  { false,         false,           497,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BrowserSwitcherUrlList
  { false,         false,           496,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // BuiltInDnsClientEnabled
  { false,         false,           165,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForCas
  { false,         false,           435,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForLegacyCas
  { false,         false,           436,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CertificateTransparencyEnforcementDisabledForUrls
  { false,         false,           335,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // CloudManagementEnrollmentMandatory
  { false,         false,           505,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudPolicyOverridesMachinePolicy
  { false,         false,           381,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudPrintProxyEnabled
  { false,         false,            13,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudPrintSubmitEnabled
  { false,         false,           109,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CloudReportingEnabled
  { false,         false,           493,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_GOOGLE_SHARING } },
  // CoalesceH2ConnectionsWithClientCertificatesForHosts
  { false,         false,           466,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ComponentUpdatesEnabled
  { false,         false,           342,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackDefaultFilteringBehavior
  { true,          false,           204,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackManualBehaviorHosts
  { true,          false,           205,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ContentPackManualBehaviorURLs
  { true,          false,           206,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesAllowedForUrls
  { false,         false,            77,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesBlockedForUrls
  { false,         false,            67,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // CookiesSessionOnlyForUrls
  { false,         false,            68,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultBrowserSettingEnabled
  { false,         false,             3,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultCookiesSetting
  { false,         false,            48,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultDownloadDirectory
  { false,         false,           401,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // DefaultGeolocationSetting
  { false,         false,            54,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultImagesSetting
  { false,         false,            49,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultJavaScriptSetting
  { false,         false,            50,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultMediaStreamSetting
  { true,          false,           149,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultNotificationsSetting
  { false,         false,            53,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPluginsSetting
  { false,         false,            51,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPopupsSetting
  { false,         false,            52,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultPrinterSelection
  { false,         false,           308,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderAlternateURLs
  { false,         false,           161,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderEnabled
  { false,         false,            40,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderEncodings
  { false,         false,            47,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderIconURL
  { false,         false,            46,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderImageURL
  { false,         false,           229,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderImageURLPostParams
  { false,         false,           233,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderKeyword
  { false,         false,            42,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderName
  { false,         false,            41,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultSearchProviderNewTabURL
  { false,         false,           237,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSearchURL
  { false,         false,            43,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultSearchProviderSearchURLPostParams
  { false,         false,           230,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSuggestURL
  { false,         false,            44,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultSearchProviderSuggestURLPostParams
  { false,         false,           231,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DefaultWebBluetoothGuardSetting
  { false,         false,           320,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DefaultWebUsbGuardSetting
  { false,         false,           434,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // DeveloperToolsAvailability
  { false,         false,           443,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DeveloperToolsDisabled
  { true,          false,            36,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // Disable3DAPIs
  { false,         false,            55,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableAuthNegotiateCnameLookup
  { false,         false,            27,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisablePrintPreview
  { false,         false,           117,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableSafeBrowsingProceedAnyway
  { false,         false,           150,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisableScreenshots
  { false,         false,           153,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledPlugins
  { true,          false,            19,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledPluginsExceptions
  { true,          false,            79,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DisabledSchemes
  { true,          false,            85,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DiskCacheDir
  { false,         false,            88,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DiskCacheSize
  { false,         false,           110,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // DownloadDirectory
  { false,         false,            64,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // DownloadRestrictions
  { false,         false,           371,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // EditBookmarksEnabled
  { false,         false,            83,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableAuthNegotiatePort
  { false,         false,            28,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableDeprecatedWebPlatformFeatures
  { false,         false,           270,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnableMediaRouter
  { false,         false,           333,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // EnableOnlineRevocationChecks
  { false,         false,           129,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // EnableSymantecLegacyInfrastructure
  { false,         false,           413,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnabledPlugins
  { true,          false,            78,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // EnterpriseHardwarePlatformAPIEnabled
  { false,         false,           483,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionAllowedTypes
  { false,         false,           168,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionInstallBlacklist
  { false,         false,            32,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionInstallForcelist
  { false,         false,            34,                        0,
    { RISK_TAG_FULL_ADMIN_ACCESS, RISK_TAG_NONE } },
  // ExtensionInstallSources
  { false,         false,           148,                        0,
    { RISK_TAG_FULL_ADMIN_ACCESS, RISK_TAG_SYSTEM_SECURITY } },
  // ExtensionInstallWhitelist
  { false,         false,            33,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ExtensionSettings
  { false,         false,           278,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ForceEphemeralProfiles
  { false,         false,           245,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ForceGoogleSafeSearch
  { false,         false,           282,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceSafeSearch
  { true,          false,           162,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceYouTubeRestrict
  { false,         false,           348,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // ForceYouTubeSafetyMode
  { true,          false,           283,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // FullscreenAllowed
  { false,         false,           240,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // GSSAPILibraryName
  { false,         false,            31,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HardwareAccelerationModeEnabled
  { false,         false,           304,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HideWebStoreIcon
  { false,         false,           189,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HomepageIsNewTabPage
  { false,         false,             2,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // HomepageLocation
  { false,         false,             1,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // Http09OnNonDefaultPortsEnabled
  { false,         false,           345,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImagesAllowedForUrls
  { false,         false,            69,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImagesBlockedForUrls
  { false,         false,            70,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ImportAutofillFormData
  { false,         false,           277,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportBookmarks
  { false,         false,            97,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportHistory
  { false,         false,            98,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportHomepage
  { false,         false,            99,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportSavedPasswords
  { false,         false,           101,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // ImportSearchEngine
  { false,         false,           100,                        0,
    { RISK_TAG_LOCAL_DATA_ACCESS, RISK_TAG_NONE } },
  // IncognitoEnabled
  { true,          false,            10,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // IncognitoModeAvailability
  { false,         false,            93,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // IsolateOrigins
  { false,         false,           398,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // JavaScriptAllowedForUrls
  { false,         false,            71,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // JavaScriptBlockedForUrls
  { false,         false,            72,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // JavascriptEnabled
  { true,          false,             9,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MachineLevelUserCloudPolicyEnrollmentToken
  { false,         false,           428,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ManagedBookmarks
  { false,         false,           227,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MaxConnectionsPerProxy
  { false,         false,            92,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MaxInvalidationFetchDelay
  { false,         false,           228,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MediaCacheSize
  { false,         false,           111,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MediaRouterCastAllowAllIPs
  { false,         false,           437,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // MetricsReportingEnabled
  { false,         false,            15,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // NativeMessagingBlacklist
  { false,         false,           251,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NativeMessagingUserLevelHosts
  { false,         false,           253,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NativeMessagingWhitelist
  { false,         false,           252,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NetworkPredictionOptions
  { false,         false,           273,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NewTabPageLocation
  { false,         false,           360,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NotificationsAllowedForUrls
  { false,         false,           105,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NotificationsBlockedForUrls
  { false,         false,           106,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // NtlmV2Enabled
  { false,         false,           393,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // OverrideSecurityRestrictionsOnInsecureOrigin
  { false,         false,           457,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // PacHttpsUrlStrippingEnabled
  { false,         false,           332,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // PasswordManagerEnabled
  { false,         false,            16,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PasswordProtectionChangePasswordURL
  { false,         false,           424,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PasswordProtectionLoginURLs
  { false,         false,           423,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PasswordProtectionWarningTrigger
  { false,         false,           411,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PluginsAllowedForUrls
  { false,         false,            73,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PluginsBlockedForUrls
  { false,         false,            74,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PopupsAllowedForUrls
  { false,         false,            75,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PopupsBlockedForUrls
  { false,         false,            76,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PrintHeaderFooter
  { false,         false,           480,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PrintPreviewUseSystemDefaultPrinter
  { false,         false,           373,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PrintingEnabled
  { false,         false,            12,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PromotionalTabsEnabled
  { false,         false,           454,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // PromptForDownloadLocation
  { false,         false,           395,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyBypassList
  { false,         false,            25,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyMode
  { false,         false,            21,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyPacUrl
  { false,         false,            24,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyServer
  { false,         false,            23,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxyServerMode
  { true,          false,            22,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ProxySettings
  { false,         false,           116,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // QuicAllowed
  { false,         false,           301,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RegisteredProtocolHandlers
  { false,         false,           268,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RelaunchNotification
  { false,         false,           419,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RelaunchNotificationPeriod
  { false,         false,           420,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowClientPairing
  { false,         false,           234,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowGnubbyAuth
  { false,         false,           257,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostAllowRelayedConnection
  { false,         false,           263,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostClientDomain
  { true,          false,           316,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostClientDomainList
  { false,         false,           369,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostDomain
  { true,          false,           154,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostDomainList
  { false,         false,           368,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostFirewallTraversal
  { false,         false,            95,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostMatchUsername
  { false,         false,           285,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostRequireCurtain
  { false,         false,           157,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // RemoteAccessHostTalkGadgetPrefix
  { false,         false,           156,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostTokenUrl
  { false,         false,           286,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // RemoteAccessHostTokenValidationCertificateIssuer
  { false,         false,           288,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RemoteAccessHostTokenValidationUrl
  { false,         false,           287,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // RemoteAccessHostUdpPortRange
  { false,         false,           264,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ReportExtensionsAndPluginsData
  { false,         false,           499,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // ReportMachineIDData
  { false,         false,           472,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // ReportPolicyData
  { false,         false,           471,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // ReportSafeBrowsingData
  { false,         false,           500,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // ReportUserIDData
  { false,         false,           473,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // ReportVersionData
  { false,         false,           470,                        0,
    { RISK_TAG_ADMIN_SHARING, RISK_TAG_NONE } },
  // RequireOnlineRevocationChecksForLocalAnchors
  { false,         false,           235,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestoreOnStartup
  { false,         false,            37,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestoreOnStartupURLs
  { false,         false,            38,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RestrictSigninToPattern
  { false,         false,           147,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // RunAllFlashInAllowMode
  { false,         false,           391,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SSLErrorOverrideAllowed
  { false,         false,           300,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SSLVersionMax
  { false,         false,           361,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SSLVersionMin
  { false,         false,           279,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SafeBrowsingEnabled
  { false,         false,            14,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SafeBrowsingExtendedReportingEnabled
  { false,         false,           429,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // SafeBrowsingExtendedReportingOptInAllowed
  { true,          false,           299,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SafeBrowsingWhitelistDomains
  { false,         false,           422,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SafeSitesFilterBehavior
  { false,         false,           455,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_GOOGLE_SHARING } },
  // SavingBrowserHistoryDisabled
  { false,         false,            11,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SearchSuggestEnabled
  { false,         false,             6,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SecurityKeyPermitAttestation
  { false,         false,           402,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // ShowAppsShortcutInBookmarkBar
  { false,         false,           267,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ShowCastIconInToolbar
  { false,         false,           362,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // ShowHomeButton
  { false,         false,            35,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SigninAllowed
  { true,          false,           190,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SitePerProcess
  { false,         false,           399,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SpellCheckServiceEnabled
  { false,         false,           151,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SpellcheckEnabled
  { false,         false,           408,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SpellcheckLanguage
  { false,         false,           405,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // SuppressUnsupportedOSWarning
  { false,         false,           324,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // SyncDisabled
  { false,         false,            20,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_GOOGLE_SHARING } },
  // TaskManagerEndProcessEnabled
  { false,         false,           327,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // TranslateEnabled
  { false,         false,            80,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // URLBlacklist
  { false,         false,           103,                        0,
    { RISK_TAG_FILTERING, RISK_TAG_NONE } },
  // URLWhitelist
  { false,         false,           104,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // UnsafelyTreatInsecureOriginAsSecure
  { true,          false,           400,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // UrlKeyedAnonymizedDataCollectionEnabled
  { false,         false,           461,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // VariationsRestrictParameter
  { false,         false,           196,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // VideoCaptureAllowed
  { false,         false,           167,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // VideoCaptureAllowedUrls
  { false,         false,           209,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // WPADQuickCheckEnabled
  { false,         false,           261,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // WebDriverOverridesIncompatiblePolicies
  { false,         false,           414,                        0,
    { RISK_TAG_SYSTEM_SECURITY, RISK_TAG_NONE } },
  // WebRtcEventLogCollectionAllowed
  { false,         false,           464,                        0,
    { RISK_TAG_GOOGLE_SHARING, RISK_TAG_NONE } },
  // WebRtcUdpPortRange
  { false,         false,           339,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
  // WebUsbAllowDevicesForUrls
  { false,         false,           486,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // WebUsbAskForUrls
  { false,         false,           439,                        0,
    { RISK_TAG_WEBSITE_SHARING, RISK_TAG_NONE } },
  // WebUsbBlockedForUrls
  { false,         false,           440,                        0,
    { RISK_TAG_NONE, RISK_TAG_NONE } },
};

const internal::SchemaNode kSchemas[] = {
//  Type                          Extra
  { base::Value::Type::DICTIONARY,   11 },  // root node
  { base::Value::Type::BOOLEAN,      -1 },  // simple type: boolean
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): AdsSettingForIntrusiveAdsSites
  { base::Value::Type::STRING,       -1 },  // simple type: string
  { base::Value::Type::LIST,          3 },  // simple type: stringlist
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): BrowserSignin
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): ContentPackDefaultFilteringBehavior
  { base::Value::Type::DICTIONARY,    0 },  // ContentPackManualBehaviorHosts
  { base::Value::Type::DICTIONARY,    1 },  // ContentPackManualBehaviorURLs
  { base::Value::Type::INTEGER,       2 },  // integer with enumeration restriction: DefaultCookiesSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultGeolocationSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultImagesSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultJavaScriptSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultMediaStreamSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultNotificationsSetting
  { base::Value::Type::INTEGER,       3 },  // integer with enumeration restriction (use range instead): DefaultPluginsSetting
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): DefaultPopupsSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultWebBluetoothGuardSetting
  { base::Value::Type::INTEGER,       4 },  // integer with enumeration restriction (use range instead): DefaultWebUsbGuardSetting
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): DeveloperToolsAvailability
  { base::Value::Type::INTEGER,      -1 },  // simple type: integer
  { base::Value::Type::INTEGER,       5 },  // integer with enumeration restriction (use range instead): DownloadRestrictions
  { base::Value::Type::DICTIONARY,    5 },  // ExtensionSettings
  { base::Value::Type::DICTIONARY,    2 },  // *
  { base::Value::Type::STRING,        6 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::DICTIONARY,    3 },  // ^update_url:
  { base::Value::Type::STRING,        7 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::DICTIONARY,    4 },  // ^[a-p]{32}$
  { base::Value::Type::STRING,        8 },  // string with enumeration restriction: installation_mode
  { base::Value::Type::STRING,        9 },  // string with pattern restriction: minimum_version_required
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): ForceYouTubeRestrict
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): IncognitoModeAvailability
  { base::Value::Type::DICTIONARY,    6 },  // items of ManagedBookmarks
  { base::Value::Type::LIST,         32 },  // 
  { base::Value::Type::LIST,         32 },  // 
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): NetworkPredictionOptions
  { base::Value::Type::INTEGER,       1 },  // integer with enumeration restriction (use range instead): PasswordProtectionWarningTrigger
  { base::Value::Type::STRING,       10 },  // string with enumeration restriction: ProxyMode
  { base::Value::Type::INTEGER,       5 },  // integer with enumeration restriction (use range instead): ProxyServerMode
  { base::Value::Type::DICTIONARY,    7 },  // ProxySettings
  { base::Value::Type::DICTIONARY,    8 },  // url
  { base::Value::Type::LIST,         40 },  // 
  { base::Value::Type::INTEGER,       0 },  // integer with enumeration restriction (use range instead): RelaunchNotification
  { base::Value::Type::INTEGER,      11 },  // integer with ranged restriction: RelaunchNotificationPeriod
  { base::Value::Type::INTEGER,      12 },  // integer with enumeration restriction: RestoreOnStartup
  { base::Value::Type::STRING,       13 },  // string with enumeration restriction: SSLVersionMax
  { base::Value::Type::STRING,       14 },  // string with enumeration restriction: SSLVersionMin
  { base::Value::Type::INTEGER,      15 },  // integer with enumeration restriction (use range instead): SafeSitesFilterBehavior
  { base::Value::Type::DICTIONARY,   10 },  // urls
  { base::Value::Type::DICTIONARY,    9 },  // items of devices
  { base::Value::Type::LIST,         49 },  // 
  { base::Value::Type::LIST,         48 },  // 
  { base::Value::Type::DICTIONARY,   16 },  // validation_schema root node
  { base::Value::Type::DICTIONARY,   14 },  // items of AutoSelectCertificateForUrls
  { base::Value::Type::DICTIONARY,   13 },  // filter
  { base::Value::Type::DICTIONARY,   12 },  // ISSUER
  { base::Value::Type::LIST,         53 },  // 
  { base::Value::Type::DICTIONARY,   15 },  // DefaultPrinterSelection
  { base::Value::Type::STRING,       16 },  // string with enumeration restriction: kind
};

const internal::PropertyNode kPropertyNodes[] = {
//  Property                                          #Schema
  { "allowed_types",                                        4 },
  { "blocked_install_message",                              3 },
  { "blocked_permissions",                                  4 },
  { "install_sources",                                      4 },
  { "installation_mode",                                   24 },
  { "runtime_allowed_hosts",                                4 },
  { "runtime_blocked_hosts",                                4 },
  { "allowed_permissions",                                  4 },
  { "blocked_permissions",                                  4 },
  { "installation_mode",                                   26 },
  { "allowed_permissions",                                  4 },
  { "blocked_install_message",                              3 },
  { "blocked_permissions",                                  4 },
  { "installation_mode",                                   28 },
  { "minimum_version_required",                            29 },
  { "runtime_allowed_hosts",                                4 },
  { "runtime_blocked_hosts",                                4 },
  { "update_url",                                           3 },
  { "*",                                                   23 },
  { "^update_url:",                                        25 },
  { "^[a-p]{32}$",                                         27 },
  { "children",                                            33 },
  { "name",                                                 3 },
  { "toplevel_name",                                        3 },
  { "url",                                                  3 },
  { key::kProxyBypassList,                                  3 },
  { key::kProxyMode,                                        3 },
  { key::kProxyPacUrl,                                      3 },
  { key::kProxyServer,                                      3 },
  { key::kProxyServerMode,                                 38 },
  { "default",                                              1 },
  { "protocol",                                             3 },
  { "url",                                                  3 },
  { "product_id",                                          20 },
  { "vendor_id",                                           20 },
  { "devices",                                             50 },
  { "urls",                                                 4 },
  { key::kAbusiveExperienceInterventionEnforce,             1 },
  { key::kAdsSettingForIntrusiveAdsSites,                   2 },
  { key::kAllowCrossOriginAuthPrompt,                       1 },
  { key::kAllowDeletingBrowserHistory,                      1 },
  { key::kAllowDinosaurEasterEgg,                           1 },
  { key::kAllowFileSelectionDialogs,                        1 },
  { key::kAllowOutdatedPlugins,                             1 },
  { key::kAllowedDomainsForApps,                            3 },
  { key::kAlternateErrorPagesEnabled,                       1 },
  { key::kAlternativeBrowserParameters,                     4 },
  { key::kAlternativeBrowserPath,                           3 },
  { key::kAlwaysOpenPdfExternally,                          1 },
  { key::kAudioCaptureAllowed,                              1 },
  { key::kAudioCaptureAllowedUrls,                          4 },
  { key::kAuthNegotiateDelegateWhitelist,                   3 },
  { key::kAuthSchemes,                                      3 },
  { key::kAuthServerWhitelist,                              3 },
  { key::kAutoFillEnabled,                                  1 },
  { key::kAutoSelectCertificateForUrls,                     4 },
  { key::kAutofillAddressEnabled,                           1 },
  { key::kAutofillCreditCardEnabled,                        1 },
  { key::kAutoplayAllowed,                                  1 },
  { key::kAutoplayWhitelist,                                4 },
  { key::kBackgroundModeEnabled,                            1 },
  { key::kBlockThirdPartyCookies,                           1 },
  { key::kBookmarkBarEnabled,                               1 },
  { key::kBrowserAddPersonEnabled,                          1 },
  { key::kBrowserGuestModeEnabled,                          1 },
  { key::kBrowserNetworkTimeQueriesEnabled,                 1 },
  { key::kBrowserSignin,                                    5 },
  { key::kBrowserSwitcherUrlGreylist,                       4 },
  { key::kBrowserSwitcherUrlList,                           4 },
  { key::kBuiltInDnsClientEnabled,                          1 },
  { key::kCertificateTransparencyEnforcementDisabledForCas,      4 },
  { key::kCertificateTransparencyEnforcementDisabledForLegacyCas,      4 },
  { key::kCertificateTransparencyEnforcementDisabledForUrls,      4 },
  { key::kCloudManagementEnrollmentMandatory,               1 },
  { key::kCloudPolicyOverridesMachinePolicy,                1 },
  { key::kCloudPrintProxyEnabled,                           1 },
  { key::kCloudPrintSubmitEnabled,                          1 },
  { key::kCloudReportingEnabled,                            1 },
  { key::kCoalesceH2ConnectionsWithClientCertificatesForHosts,      4 },
  { key::kComponentUpdatesEnabled,                          1 },
  { key::kContentPackDefaultFilteringBehavior,              6 },
  { key::kContentPackManualBehaviorHosts,                   7 },
  { key::kContentPackManualBehaviorURLs,                    8 },
  { key::kCookiesAllowedForUrls,                            4 },
  { key::kCookiesBlockedForUrls,                            4 },
  { key::kCookiesSessionOnlyForUrls,                        4 },
  { key::kDefaultBrowserSettingEnabled,                     1 },
  { key::kDefaultCookiesSetting,                            9 },
  { key::kDefaultDownloadDirectory,                         3 },
  { key::kDefaultGeolocationSetting,                       10 },
  { key::kDefaultImagesSetting,                            11 },
  { key::kDefaultJavaScriptSetting,                        12 },
  { key::kDefaultMediaStreamSetting,                       13 },
  { key::kDefaultNotificationsSetting,                     14 },
  { key::kDefaultPluginsSetting,                           15 },
  { key::kDefaultPopupsSetting,                            16 },
  { key::kDefaultPrinterSelection,                          3 },
  { key::kDefaultSearchProviderAlternateURLs,               4 },
  { key::kDefaultSearchProviderEnabled,                     1 },
  { key::kDefaultSearchProviderEncodings,                   4 },
  { key::kDefaultSearchProviderIconURL,                     3 },
  { key::kDefaultSearchProviderImageURL,                    3 },
  { key::kDefaultSearchProviderImageURLPostParams,          3 },
  { key::kDefaultSearchProviderKeyword,                     3 },
  { key::kDefaultSearchProviderName,                        3 },
  { key::kDefaultSearchProviderNewTabURL,                   3 },
  { key::kDefaultSearchProviderSearchURL,                   3 },
  { key::kDefaultSearchProviderSearchURLPostParams,         3 },
  { key::kDefaultSearchProviderSuggestURL,                  3 },
  { key::kDefaultSearchProviderSuggestURLPostParams,        3 },
  { key::kDefaultWebBluetoothGuardSetting,                 17 },
  { key::kDefaultWebUsbGuardSetting,                       18 },
  { key::kDeveloperToolsAvailability,                      19 },
  { key::kDeveloperToolsDisabled,                           1 },
  { key::kDisable3DAPIs,                                    1 },
  { key::kDisableAuthNegotiateCnameLookup,                  1 },
  { key::kDisablePrintPreview,                              1 },
  { key::kDisableSafeBrowsingProceedAnyway,                 1 },
  { key::kDisableScreenshots,                               1 },
  { key::kDisabledPlugins,                                  4 },
  { key::kDisabledPluginsExceptions,                        4 },
  { key::kDisabledSchemes,                                  4 },
  { key::kDiskCacheDir,                                     3 },
  { key::kDiskCacheSize,                                   20 },
  { key::kDownloadDirectory,                                3 },
  { key::kDownloadRestrictions,                            21 },
  { key::kEditBookmarksEnabled,                             1 },
  { key::kEnableAuthNegotiatePort,                          1 },
  { key::kEnableDeprecatedWebPlatformFeatures,              4 },
  { key::kEnableMediaRouter,                                1 },
  { key::kEnableOnlineRevocationChecks,                     1 },
  { key::kEnableSymantecLegacyInfrastructure,               1 },
  { key::kEnabledPlugins,                                   4 },
  { key::kEnterpriseHardwarePlatformAPIEnabled,             1 },
  { key::kExtensionAllowedTypes,                            4 },
  { key::kExtensionInstallBlacklist,                        4 },
  { key::kExtensionInstallForcelist,                        4 },
  { key::kExtensionInstallSources,                          4 },
  { key::kExtensionInstallWhitelist,                        4 },
  { key::kExtensionSettings,                               22 },
  { key::kForceEphemeralProfiles,                           1 },
  { key::kForceGoogleSafeSearch,                            1 },
  { key::kForceSafeSearch,                                  1 },
  { key::kForceYouTubeRestrict,                            30 },
  { key::kForceYouTubeSafetyMode,                           1 },
  { key::kFullscreenAllowed,                                1 },
  { key::kGSSAPILibraryName,                                3 },
  { key::kHardwareAccelerationModeEnabled,                  1 },
  { key::kHideWebStoreIcon,                                 1 },
  { key::kHomepageIsNewTabPage,                             1 },
  { key::kHomepageLocation,                                 3 },
  { key::kHttp09OnNonDefaultPortsEnabled,                   1 },
  { key::kImagesAllowedForUrls,                             4 },
  { key::kImagesBlockedForUrls,                             4 },
  { key::kImportAutofillFormData,                           1 },
  { key::kImportBookmarks,                                  1 },
  { key::kImportHistory,                                    1 },
  { key::kImportHomepage,                                   1 },
  { key::kImportSavedPasswords,                             1 },
  { key::kImportSearchEngine,                               1 },
  { key::kIncognitoEnabled,                                 1 },
  { key::kIncognitoModeAvailability,                       31 },
  { key::kIsolateOrigins,                                   3 },
  { key::kJavaScriptAllowedForUrls,                         4 },
  { key::kJavaScriptBlockedForUrls,                         4 },
  { key::kJavascriptEnabled,                                1 },
  { key::kMachineLevelUserCloudPolicyEnrollmentToken,       3 },
  { key::kManagedBookmarks,                                34 },
  { key::kMaxConnectionsPerProxy,                          20 },
  { key::kMaxInvalidationFetchDelay,                       20 },
  { key::kMediaCacheSize,                                  20 },
  { key::kMediaRouterCastAllowAllIPs,                       1 },
  { key::kMetricsReportingEnabled,                          1 },
  { key::kNativeMessagingBlacklist,                         4 },
  { key::kNativeMessagingUserLevelHosts,                    1 },
  { key::kNativeMessagingWhitelist,                         4 },
  { key::kNetworkPredictionOptions,                        35 },
  { key::kNewTabPageLocation,                               3 },
  { key::kNotificationsAllowedForUrls,                      4 },
  { key::kNotificationsBlockedForUrls,                      4 },
  { key::kNtlmV2Enabled,                                    1 },
  { key::kOverrideSecurityRestrictionsOnInsecureOrigin,      4 },
  { key::kPacHttpsUrlStrippingEnabled,                      1 },
  { key::kPasswordManagerEnabled,                           1 },
  { key::kPasswordProtectionChangePasswordURL,              3 },
  { key::kPasswordProtectionLoginURLs,                      4 },
  { key::kPasswordProtectionWarningTrigger,                36 },
  { key::kPluginsAllowedForUrls,                            4 },
  { key::kPluginsBlockedForUrls,                            4 },
  { key::kPopupsAllowedForUrls,                             4 },
  { key::kPopupsBlockedForUrls,                             4 },
  { key::kPrintHeaderFooter,                                1 },
  { key::kPrintPreviewUseSystemDefaultPrinter,              1 },
  { key::kPrintingEnabled,                                  1 },
  { key::kPromotionalTabsEnabled,                           1 },
  { key::kPromptForDownloadLocation,                        1 },
  { key::kProxyBypassList,                                  3 },
  { key::kProxyMode,                                       37 },
  { key::kProxyPacUrl,                                      3 },
  { key::kProxyServer,                                      3 },
  { key::kProxyServerMode,                                 38 },
  { key::kProxySettings,                                   39 },
  { key::kQuicAllowed,                                      1 },
  { key::kRegisteredProtocolHandlers,                      41 },
  { key::kRelaunchNotification,                            42 },
  { key::kRelaunchNotificationPeriod,                      43 },
  { key::kRemoteAccessHostAllowClientPairing,               1 },
  { key::kRemoteAccessHostAllowGnubbyAuth,                  1 },
  { key::kRemoteAccessHostAllowRelayedConnection,           1 },
  { key::kRemoteAccessHostClientDomain,                     3 },
  { key::kRemoteAccessHostClientDomainList,                 4 },
  { key::kRemoteAccessHostDomain,                           3 },
  { key::kRemoteAccessHostDomainList,                       4 },
  { key::kRemoteAccessHostFirewallTraversal,                1 },
  { key::kRemoteAccessHostMatchUsername,                    1 },
  { key::kRemoteAccessHostRequireCurtain,                   1 },
  { key::kRemoteAccessHostTalkGadgetPrefix,                 3 },
  { key::kRemoteAccessHostTokenUrl,                         3 },
  { key::kRemoteAccessHostTokenValidationCertificateIssuer,      3 },
  { key::kRemoteAccessHostTokenValidationUrl,               3 },
  { key::kRemoteAccessHostUdpPortRange,                     3 },
  { key::kReportExtensionsAndPluginsData,                   1 },
  { key::kReportMachineIDData,                              1 },
  { key::kReportPolicyData,                                 1 },
  { key::kReportSafeBrowsingData,                           1 },
  { key::kReportUserIDData,                                 1 },
  { key::kReportVersionData,                                1 },
  { key::kRequireOnlineRevocationChecksForLocalAnchors,      1 },
  { key::kRestoreOnStartup,                                44 },
  { key::kRestoreOnStartupURLs,                             4 },
  { key::kRestrictSigninToPattern,                          3 },
  { key::kRunAllFlashInAllowMode,                           1 },
  { key::kSSLErrorOverrideAllowed,                          1 },
  { key::kSSLVersionMax,                                   45 },
  { key::kSSLVersionMin,                                   46 },
  { key::kSafeBrowsingEnabled,                              1 },
  { key::kSafeBrowsingExtendedReportingEnabled,             1 },
  { key::kSafeBrowsingExtendedReportingOptInAllowed,        1 },
  { key::kSafeBrowsingWhitelistDomains,                     4 },
  { key::kSafeSitesFilterBehavior,                         47 },
  { key::kSavingBrowserHistoryDisabled,                     1 },
  { key::kSearchSuggestEnabled,                             1 },
  { key::kSecurityKeyPermitAttestation,                     4 },
  { key::kShowAppsShortcutInBookmarkBar,                    1 },
  { key::kShowCastIconInToolbar,                            1 },
  { key::kShowHomeButton,                                   1 },
  { key::kSigninAllowed,                                    1 },
  { key::kSitePerProcess,                                   1 },
  { key::kSpellCheckServiceEnabled,                         1 },
  { key::kSpellcheckEnabled,                                1 },
  { key::kSpellcheckLanguage,                               4 },
  { key::kSuppressUnsupportedOSWarning,                     1 },
  { key::kSyncDisabled,                                     1 },
  { key::kTaskManagerEndProcessEnabled,                     1 },
  { key::kTranslateEnabled,                                 1 },
  { key::kURLBlacklist,                                     4 },
  { key::kURLWhitelist,                                     4 },
  { key::kUnsafelyTreatInsecureOriginAsSecure,              4 },
  { key::kUrlKeyedAnonymizedDataCollectionEnabled,          1 },
  { key::kVariationsRestrictParameter,                      3 },
  { key::kVideoCaptureAllowed,                              1 },
  { key::kVideoCaptureAllowedUrls,                          4 },
  { key::kWPADQuickCheckEnabled,                            1 },
  { key::kWebDriverOverridesIncompatiblePolicies,           1 },
  { key::kWebRtcEventLogCollectionAllowed,                  1 },
  { key::kWebRtcUdpPortRange,                               3 },
  { key::kWebUsbAllowDevicesForUrls,                       51 },
  { key::kWebUsbAskForUrls,                                 4 },
  { key::kWebUsbBlockedForUrls,                             4 },
  { "CN",                                                   3 },
  { "ISSUER",                                              55 },
  { "filter",                                              54 },
  { "pattern",                                              3 },
  { "idPattern",                                            3 },
  { "kind",                                                58 },
  { "namePattern",                                          3 },
  { key::kAutoSelectCertificateForUrls,                    56 },
  { key::kDefaultPrinterSelection,                         57 },
};

const internal::PropertiesNode kProperties[] = {
//  Begin    End  PatternEnd  RequiredBegin  RequiredEnd  Additional Properties
  {     0,     0,     0,     0,          0,     1 },  // ContentPackManualBehaviorHosts
  {     0,     0,     0,     0,          0,     1 },  // ContentPackManualBehaviorURLs
  {     0,     7,     7,     0,          0,    -1 },  // *
  {     7,    10,    10,     0,          0,    -1 },  // ^update_url:
  {    10,    18,    18,     0,          0,    -1 },  // ^[a-p]{32}$
  {    18,    19,    21,     0,          0,    -1 },  // ExtensionSettings
  {    21,    25,    25,     0,          0,    -1 },  // items of ManagedBookmarks
  {    25,    30,    30,     0,          0,    -1 },  // ProxySettings
  {    30,    33,    33,     0,          2,    -1 },  // url
  {    33,    35,    35,     2,          2,    -1 },  // items of devices
  {    35,    37,    37,     2,          4,    -1 },  // urls
  {    37,   269,   269,     4,          4,    -1 },  // root node
  {   269,   270,   270,     4,          4,    -1 },  // ISSUER
  {   270,   271,   271,     4,          4,    -1 },  // filter
  {   271,   273,   273,     4,          4,    -1 },  // items of AutoSelectCertificateForUrls
  {   273,   276,   276,     4,          4,    -1 },  // DefaultPrinterSelection
  {   276,   278,   278,     4,          4,    -1 },  // validation_schema root node
};

const internal::RestrictionNode kRestrictionNodes[] = {
//   FIRST, SECOND
  {{ 2,          1}},
  {{ 2,          0}},
  {{ 0,          3}},
  {{ 3,          1}},
  {{ 3,          2}},
  {{ 3,          0}},
  {{ 0,          2}},
  {{ 2,          4}},
  {{ 4,          8}},
  {{ 8,          8}},
  {{ 9,         14}},
  {{ INT_MAX, 3600000}},
  {{ 3,          6}},
  {{ 14,        16}},
  {{ 16,        19}},
  {{ 1,          0}},
  {{ 19,        21}},
};

const char* const kRequiredProperties[] = {
  "protocol",
  "url",
  "devices",
  "urls",
};

const int kIntegerEnumerations[] = {
  1,
  2,
  4,
  1,
  4,
  5,
};

const char* const kStringEnumerations[] = {
  "blocked",
  "allowed",
  "blocked",
  "allowed",
  "blocked",
  "allowed",
  "force_installed",
  "normal_installed",
  "^[0-9]+([.][0-9]+)*$",
  "direct",
  "auto_detect",
  "pac_script",
  "fixed_servers",
  "system",
  "tls1.2",
  "tls1.3",
  "tls1",
  "tls1.1",
  "tls1.2",
  "local",
  "cloud",
};

const internal::SchemaData kChromeSchemaData = {
  kSchemas,
  kPropertyNodes,
  kProperties,
  kRestrictionNodes,
  kRequiredProperties,
  kIntegerEnumerations,
  kStringEnumerations,
  52,  // validation_schema root index
  nullptr,  // schema_nodes_metadata
};


namespace {
bool CompareKeys(const internal::PropertyNode& node,
                 const std::string& key) {
  return node.key < key;
}

}  // namespace

const internal::SchemaData* GetChromeSchemaData() {
  return &kChromeSchemaData;
}

#if defined (OS_CHROMEOS)
void SetEnterpriseUsersDefaults(PolicyMap* policy_map) {
  if (!policy_map->Get(key::kAllowDinosaurEasterEgg)) {
    policy_map->Set(key::kAllowDinosaurEasterEgg,
                    POLICY_LEVEL_MANDATORY,
                    POLICY_SCOPE_USER,
                    POLICY_SOURCE_ENTERPRISE_DEFAULT,
                    std::make_unique<base::Value>(false),
                    nullptr);
  }
}
#endif

const PolicyDetails* GetChromePolicyDetails(const std::string& policy) {
  // First index in kPropertyNodes of the Chrome policies.
  static const int begin_index = 37;
  // One-past-the-end of the Chrome policies in kPropertyNodes.
  static const int end_index = 269;
  const internal::PropertyNode* begin =
      kPropertyNodes + begin_index;
  const internal::PropertyNode* end = kPropertyNodes + end_index;
  const internal::PropertyNode* it =
      std::lower_bound(begin, end, policy, CompareKeys);
  if (it == end || it->key != policy)
    return NULL;
  // This relies on kPropertyNodes from begin_index to end_index
  // having exactly the same policies (and in the same order) as
  // kChromePolicyDetails, so that binary searching on the first
  // gets the same results as a binary search on the second would.
  // However, kPropertyNodes has the policy names and
  // kChromePolicyDetails doesn't, so we obtain the index into
  // the second array by searching the first to avoid duplicating
  // the policy name pointers.
  // Offsetting |it| from |begin| here obtains the index we're
  // looking for.
  size_t index = it - begin;
  CHECK_LT(index, arraysize(kChromePolicyDetails));
  return kChromePolicyDetails + index;
}

namespace key {

const char kAbusiveExperienceInterventionEnforce[] = "AbusiveExperienceInterventionEnforce";
const char kAdditionalLaunchParameters[] = "AdditionalLaunchParameters";
const char kAdsSettingForIntrusiveAdsSites[] = "AdsSettingForIntrusiveAdsSites";
const char kAllowCrossOriginAuthPrompt[] = "AllowCrossOriginAuthPrompt";
const char kAllowDeletingBrowserHistory[] = "AllowDeletingBrowserHistory";
const char kAllowDinosaurEasterEgg[] = "AllowDinosaurEasterEgg";
const char kAllowFileSelectionDialogs[] = "AllowFileSelectionDialogs";
const char kAllowKioskAppControlChromeVersion[] = "AllowKioskAppControlChromeVersion";
const char kAllowOutdatedPlugins[] = "AllowOutdatedPlugins";
const char kAllowScreenLock[] = "AllowScreenLock";
const char kAllowScreenWakeLocks[] = "AllowScreenWakeLocks";
const char kAllowWakeLocks[] = "AllowWakeLocks";
const char kAllowedDomainsForApps[] = "AllowedDomainsForApps";
const char kAllowedInputMethods[] = "AllowedInputMethods";
const char kAllowedLanguages[] = "AllowedLanguages";
const char kAlternateErrorPagesEnabled[] = "AlternateErrorPagesEnabled";
const char kAlternativeBrowserParameters[] = "AlternativeBrowserParameters";
const char kAlternativeBrowserPath[] = "AlternativeBrowserPath";
const char kAlwaysAuthorizePlugins[] = "AlwaysAuthorizePlugins";
const char kAlwaysOpenPdfExternally[] = "AlwaysOpenPdfExternally";
const char kApplicationLocaleValue[] = "ApplicationLocaleValue";
const char kArcAppInstallEventLoggingEnabled[] = "ArcAppInstallEventLoggingEnabled";
const char kArcBackupRestoreEnabled[] = "ArcBackupRestoreEnabled";
const char kArcBackupRestoreServiceEnabled[] = "ArcBackupRestoreServiceEnabled";
const char kArcCertificatesSyncMode[] = "ArcCertificatesSyncMode";
const char kArcEnabled[] = "ArcEnabled";
const char kArcGoogleLocationServicesEnabled[] = "ArcGoogleLocationServicesEnabled";
const char kArcLocationServiceEnabled[] = "ArcLocationServiceEnabled";
const char kArcPolicy[] = "ArcPolicy";
const char kAttestationEnabledForDevice[] = "AttestationEnabledForDevice";
const char kAttestationEnabledForUser[] = "AttestationEnabledForUser";
const char kAttestationExtensionWhitelist[] = "AttestationExtensionWhitelist";
const char kAttestationForContentProtectionEnabled[] = "AttestationForContentProtectionEnabled";
const char kAudioCaptureAllowed[] = "AudioCaptureAllowed";
const char kAudioCaptureAllowedUrls[] = "AudioCaptureAllowedUrls";
const char kAudioOutputAllowed[] = "AudioOutputAllowed";
const char kAuthAndroidNegotiateAccountType[] = "AuthAndroidNegotiateAccountType";
const char kAuthNegotiateDelegateWhitelist[] = "AuthNegotiateDelegateWhitelist";
const char kAuthSchemes[] = "AuthSchemes";
const char kAuthServerWhitelist[] = "AuthServerWhitelist";
const char kAutoCleanUpStrategy[] = "AutoCleanUpStrategy";
const char kAutoFillEnabled[] = "AutoFillEnabled";
const char kAutoSelectCertificateForUrls[] = "AutoSelectCertificateForUrls";
const char kAutofillAddressEnabled[] = "AutofillAddressEnabled";
const char kAutofillCreditCardEnabled[] = "AutofillCreditCardEnabled";
const char kAutoplayAllowed[] = "AutoplayAllowed";
const char kAutoplayWhitelist[] = "AutoplayWhitelist";
const char kBackgroundModeEnabled[] = "BackgroundModeEnabled";
const char kBlockThirdPartyCookies[] = "BlockThirdPartyCookies";
const char kBookmarkBarEnabled[] = "BookmarkBarEnabled";
const char kBrowserAddPersonEnabled[] = "BrowserAddPersonEnabled";
const char kBrowserGuestModeEnabled[] = "BrowserGuestModeEnabled";
const char kBrowserNetworkTimeQueriesEnabled[] = "BrowserNetworkTimeQueriesEnabled";
const char kBrowserSignin[] = "BrowserSignin";
const char kBrowserSwitcherUrlGreylist[] = "BrowserSwitcherUrlGreylist";
const char kBrowserSwitcherUrlList[] = "BrowserSwitcherUrlList";
const char kBrowserSwitcherUseIeSitelist[] = "BrowserSwitcherUseIeSitelist";
const char kBuiltInDnsClientEnabled[] = "BuiltInDnsClientEnabled";
const char kCaptivePortalAuthenticationIgnoresProxy[] = "CaptivePortalAuthenticationIgnoresProxy";
const char kCastReceiverEnabled[] = "CastReceiverEnabled";
const char kCastReceiverName[] = "CastReceiverName";
const char kCertificateTransparencyEnforcementDisabledForCas[] = "CertificateTransparencyEnforcementDisabledForCas";
const char kCertificateTransparencyEnforcementDisabledForLegacyCas[] = "CertificateTransparencyEnforcementDisabledForLegacyCas";
const char kCertificateTransparencyEnforcementDisabledForUrls[] = "CertificateTransparencyEnforcementDisabledForUrls";
const char kChromeCleanupEnabled[] = "ChromeCleanupEnabled";
const char kChromeCleanupReportingEnabled[] = "ChromeCleanupReportingEnabled";
const char kChromeFrameContentTypes[] = "ChromeFrameContentTypes";
const char kChromeFrameRendererSettings[] = "ChromeFrameRendererSettings";
const char kChromeOsLockOnIdleSuspend[] = "ChromeOsLockOnIdleSuspend";
const char kChromeOsMultiProfileUserBehavior[] = "ChromeOsMultiProfileUserBehavior";
const char kChromeOsReleaseChannel[] = "ChromeOsReleaseChannel";
const char kChromeOsReleaseChannelDelegated[] = "ChromeOsReleaseChannelDelegated";
const char kClearSiteDataOnExit[] = "ClearSiteDataOnExit";
const char kCloudManagementEnrollmentMandatory[] = "CloudManagementEnrollmentMandatory";
const char kCloudPolicyOverridesMachinePolicy[] = "CloudPolicyOverridesMachinePolicy";
const char kCloudPrintProxyEnabled[] = "CloudPrintProxyEnabled";
const char kCloudPrintSubmitEnabled[] = "CloudPrintSubmitEnabled";
const char kCloudReportingEnabled[] = "CloudReportingEnabled";
const char kCoalesceH2ConnectionsWithClientCertificatesForHosts[] = "CoalesceH2ConnectionsWithClientCertificatesForHosts";
const char kComponentUpdatesEnabled[] = "ComponentUpdatesEnabled";
const char kContentPackDefaultFilteringBehavior[] = "ContentPackDefaultFilteringBehavior";
const char kContentPackManualBehaviorHosts[] = "ContentPackManualBehaviorHosts";
const char kContentPackManualBehaviorURLs[] = "ContentPackManualBehaviorURLs";
const char kContextualSearchEnabled[] = "ContextualSearchEnabled";
const char kContextualSuggestionsEnabled[] = "ContextualSuggestionsEnabled";
const char kCookiesAllowedForUrls[] = "CookiesAllowedForUrls";
const char kCookiesBlockedForUrls[] = "CookiesBlockedForUrls";
const char kCookiesSessionOnlyForUrls[] = "CookiesSessionOnlyForUrls";
const char kCrostiniAllowed[] = "CrostiniAllowed";
const char kDHEEnabled[] = "DHEEnabled";
const char kDataCompressionProxyEnabled[] = "DataCompressionProxyEnabled";
const char kDefaultBrowserSettingEnabled[] = "DefaultBrowserSettingEnabled";
const char kDefaultCookiesSetting[] = "DefaultCookiesSetting";
const char kDefaultDownloadDirectory[] = "DefaultDownloadDirectory";
const char kDefaultGeolocationSetting[] = "DefaultGeolocationSetting";
const char kDefaultImagesSetting[] = "DefaultImagesSetting";
const char kDefaultJavaScriptSetting[] = "DefaultJavaScriptSetting";
const char kDefaultKeygenSetting[] = "DefaultKeygenSetting";
const char kDefaultMediaStreamSetting[] = "DefaultMediaStreamSetting";
const char kDefaultNotificationsSetting[] = "DefaultNotificationsSetting";
const char kDefaultPluginsSetting[] = "DefaultPluginsSetting";
const char kDefaultPopupsSetting[] = "DefaultPopupsSetting";
const char kDefaultPrinterSelection[] = "DefaultPrinterSelection";
const char kDefaultSearchProviderAlternateURLs[] = "DefaultSearchProviderAlternateURLs";
const char kDefaultSearchProviderEnabled[] = "DefaultSearchProviderEnabled";
const char kDefaultSearchProviderEncodings[] = "DefaultSearchProviderEncodings";
const char kDefaultSearchProviderIconURL[] = "DefaultSearchProviderIconURL";
const char kDefaultSearchProviderImageURL[] = "DefaultSearchProviderImageURL";
const char kDefaultSearchProviderImageURLPostParams[] = "DefaultSearchProviderImageURLPostParams";
const char kDefaultSearchProviderInstantURL[] = "DefaultSearchProviderInstantURL";
const char kDefaultSearchProviderInstantURLPostParams[] = "DefaultSearchProviderInstantURLPostParams";
const char kDefaultSearchProviderKeyword[] = "DefaultSearchProviderKeyword";
const char kDefaultSearchProviderName[] = "DefaultSearchProviderName";
const char kDefaultSearchProviderNewTabURL[] = "DefaultSearchProviderNewTabURL";
const char kDefaultSearchProviderSearchTermsReplacementKey[] = "DefaultSearchProviderSearchTermsReplacementKey";
const char kDefaultSearchProviderSearchURL[] = "DefaultSearchProviderSearchURL";
const char kDefaultSearchProviderSearchURLPostParams[] = "DefaultSearchProviderSearchURLPostParams";
const char kDefaultSearchProviderSuggestURL[] = "DefaultSearchProviderSuggestURL";
const char kDefaultSearchProviderSuggestURLPostParams[] = "DefaultSearchProviderSuggestURLPostParams";
const char kDefaultWebBluetoothGuardSetting[] = "DefaultWebBluetoothGuardSetting";
const char kDefaultWebUsbGuardSetting[] = "DefaultWebUsbGuardSetting";
const char kDeveloperToolsAvailability[] = "DeveloperToolsAvailability";
const char kDeveloperToolsDisabled[] = "DeveloperToolsDisabled";
const char kDeviceAllowBluetooth[] = "DeviceAllowBluetooth";
const char kDeviceAllowNewUsers[] = "DeviceAllowNewUsers";
const char kDeviceAllowRedeemChromeOsRegistrationOffers[] = "DeviceAllowRedeemChromeOsRegistrationOffers";
const char kDeviceAppPack[] = "DeviceAppPack";
const char kDeviceAutoUpdateDisabled[] = "DeviceAutoUpdateDisabled";
const char kDeviceAutoUpdateP2PEnabled[] = "DeviceAutoUpdateP2PEnabled";
const char kDeviceAutoUpdateTimeRestrictions[] = "DeviceAutoUpdateTimeRestrictions";
const char kDeviceBlockDevmode[] = "DeviceBlockDevmode";
const char kDeviceDataRoamingEnabled[] = "DeviceDataRoamingEnabled";
const char kDeviceDisplayResolution[] = "DeviceDisplayResolution";
const char kDeviceEcryptfsMigrationStrategy[] = "DeviceEcryptfsMigrationStrategy";
const char kDeviceEphemeralUsersEnabled[] = "DeviceEphemeralUsersEnabled";
const char kDeviceGuestModeEnabled[] = "DeviceGuestModeEnabled";
const char kDeviceHostnameTemplate[] = "DeviceHostnameTemplate";
const char kDeviceIdleLogoutTimeout[] = "DeviceIdleLogoutTimeout";
const char kDeviceIdleLogoutWarningDuration[] = "DeviceIdleLogoutWarningDuration";
const char kDeviceKerberosEncryptionTypes[] = "DeviceKerberosEncryptionTypes";
const char kDeviceLocalAccountAutoLoginBailoutEnabled[] = "DeviceLocalAccountAutoLoginBailoutEnabled";
const char kDeviceLocalAccountAutoLoginDelay[] = "DeviceLocalAccountAutoLoginDelay";
const char kDeviceLocalAccountAutoLoginId[] = "DeviceLocalAccountAutoLoginId";
const char kDeviceLocalAccountManagedSessionEnabled[] = "DeviceLocalAccountManagedSessionEnabled";
const char kDeviceLocalAccountPromptForNetworkWhenOffline[] = "DeviceLocalAccountPromptForNetworkWhenOffline";
const char kDeviceLocalAccounts[] = "DeviceLocalAccounts";
const char kDeviceLoginScreenAppInstallList[] = "DeviceLoginScreenAppInstallList";
const char kDeviceLoginScreenAutoSelectCertificateForUrls[] = "DeviceLoginScreenAutoSelectCertificateForUrls";
const char kDeviceLoginScreenDefaultHighContrastEnabled[] = "DeviceLoginScreenDefaultHighContrastEnabled";
const char kDeviceLoginScreenDefaultLargeCursorEnabled[] = "DeviceLoginScreenDefaultLargeCursorEnabled";
const char kDeviceLoginScreenDefaultScreenMagnifierType[] = "DeviceLoginScreenDefaultScreenMagnifierType";
const char kDeviceLoginScreenDefaultSpokenFeedbackEnabled[] = "DeviceLoginScreenDefaultSpokenFeedbackEnabled";
const char kDeviceLoginScreenDefaultVirtualKeyboardEnabled[] = "DeviceLoginScreenDefaultVirtualKeyboardEnabled";
const char kDeviceLoginScreenDomainAutoComplete[] = "DeviceLoginScreenDomainAutoComplete";
const char kDeviceLoginScreenInputMethods[] = "DeviceLoginScreenInputMethods";
const char kDeviceLoginScreenIsolateOrigins[] = "DeviceLoginScreenIsolateOrigins";
const char kDeviceLoginScreenLocales[] = "DeviceLoginScreenLocales";
const char kDeviceLoginScreenPowerManagement[] = "DeviceLoginScreenPowerManagement";
const char kDeviceLoginScreenSaverId[] = "DeviceLoginScreenSaverId";
const char kDeviceLoginScreenSaverTimeout[] = "DeviceLoginScreenSaverTimeout";
const char kDeviceLoginScreenSitePerProcess[] = "DeviceLoginScreenSitePerProcess";
const char kDeviceMachinePasswordChangeRate[] = "DeviceMachinePasswordChangeRate";
const char kDeviceMetricsReportingEnabled[] = "DeviceMetricsReportingEnabled";
const char kDeviceNativePrinters[] = "DeviceNativePrinters";
const char kDeviceNativePrintersAccessMode[] = "DeviceNativePrintersAccessMode";
const char kDeviceNativePrintersBlacklist[] = "DeviceNativePrintersBlacklist";
const char kDeviceNativePrintersWhitelist[] = "DeviceNativePrintersWhitelist";
const char kDeviceOffHours[] = "DeviceOffHours";
const char kDeviceOpenNetworkConfiguration[] = "DeviceOpenNetworkConfiguration";
const char kDevicePolicyRefreshRate[] = "DevicePolicyRefreshRate";
const char kDeviceQuirksDownloadEnabled[] = "DeviceQuirksDownloadEnabled";
const char kDeviceRebootOnShutdown[] = "DeviceRebootOnShutdown";
const char kDeviceRollbackAllowedMilestones[] = "DeviceRollbackAllowedMilestones";
const char kDeviceRollbackToTargetVersion[] = "DeviceRollbackToTargetVersion";
const char kDeviceSamlLoginAuthenticationType[] = "DeviceSamlLoginAuthenticationType";
const char kDeviceSecondFactorAuthentication[] = "DeviceSecondFactorAuthentication";
const char kDeviceShowUserNamesOnSignin[] = "DeviceShowUserNamesOnSignin";
const char kDeviceStartUpFlags[] = "DeviceStartUpFlags";
const char kDeviceStartUpUrls[] = "DeviceStartUpUrls";
const char kDeviceTargetVersionPrefix[] = "DeviceTargetVersionPrefix";
const char kDeviceTransferSAMLCookies[] = "DeviceTransferSAMLCookies";
const char kDeviceUnaffiliatedCrostiniAllowed[] = "DeviceUnaffiliatedCrostiniAllowed";
const char kDeviceUpdateAllowedConnectionTypes[] = "DeviceUpdateAllowedConnectionTypes";
const char kDeviceUpdateHttpDownloadsEnabled[] = "DeviceUpdateHttpDownloadsEnabled";
const char kDeviceUpdateScatterFactor[] = "DeviceUpdateScatterFactor";
const char kDeviceUpdateStagingSchedule[] = "DeviceUpdateStagingSchedule";
const char kDeviceUserPolicyLoopbackProcessingMode[] = "DeviceUserPolicyLoopbackProcessingMode";
const char kDeviceUserWhitelist[] = "DeviceUserWhitelist";
const char kDeviceVariationsRestrictParameter[] = "DeviceVariationsRestrictParameter";
const char kDeviceWallpaperImage[] = "DeviceWallpaperImage";
const char kDeviceWiFiFastTransitionEnabled[] = "DeviceWiFiFastTransitionEnabled";
const char kDisable3DAPIs[] = "Disable3DAPIs";
const char kDisableAuthNegotiateCnameLookup[] = "DisableAuthNegotiateCnameLookup";
const char kDisablePluginFinder[] = "DisablePluginFinder";
const char kDisablePrintPreview[] = "DisablePrintPreview";
const char kDisableSSLRecordSplitting[] = "DisableSSLRecordSplitting";
const char kDisableSafeBrowsingProceedAnyway[] = "DisableSafeBrowsingProceedAnyway";
const char kDisableScreenshots[] = "DisableScreenshots";
const char kDisableSpdy[] = "DisableSpdy";
const char kDisabledPlugins[] = "DisabledPlugins";
const char kDisabledPluginsExceptions[] = "DisabledPluginsExceptions";
const char kDisabledSchemes[] = "DisabledSchemes";
const char kDiskCacheDir[] = "DiskCacheDir";
const char kDiskCacheSize[] = "DiskCacheSize";
const char kDisplayRotationDefault[] = "DisplayRotationDefault";
const char kDnsPrefetchingEnabled[] = "DnsPrefetchingEnabled";
const char kDownloadDirectory[] = "DownloadDirectory";
const char kDownloadRestrictions[] = "DownloadRestrictions";
const char kDriveDisabled[] = "DriveDisabled";
const char kDriveDisabledOverCellular[] = "DriveDisabledOverCellular";
const char kEasyUnlockAllowed[] = "EasyUnlockAllowed";
const char kEcryptfsMigrationStrategy[] = "EcryptfsMigrationStrategy";
const char kEditBookmarksEnabled[] = "EditBookmarksEnabled";
const char kEnableAuthNegotiatePort[] = "EnableAuthNegotiatePort";
const char kEnableCommonNameFallbackForLocalAnchors[] = "EnableCommonNameFallbackForLocalAnchors";
const char kEnableDeprecatedWebBasedSignin[] = "EnableDeprecatedWebBasedSignin";
const char kEnableDeprecatedWebPlatformFeatures[] = "EnableDeprecatedWebPlatformFeatures";
const char kEnableMediaRouter[] = "EnableMediaRouter";
const char kEnableMemoryInfo[] = "EnableMemoryInfo";
const char kEnableOnlineRevocationChecks[] = "EnableOnlineRevocationChecks";
const char kEnableOriginBoundCerts[] = "EnableOriginBoundCerts";
const char kEnableSha1ForLocalAnchors[] = "EnableSha1ForLocalAnchors";
const char kEnableSymantecLegacyInfrastructure[] = "EnableSymantecLegacyInfrastructure";
const char kEnableSyncConsent[] = "EnableSyncConsent";
const char kEnabledPlugins[] = "EnabledPlugins";
const char kEnterpriseHardwarePlatformAPIEnabled[] = "EnterpriseHardwarePlatformAPIEnabled";
const char kEnterpriseWebStoreName[] = "EnterpriseWebStoreName";
const char kEnterpriseWebStoreURL[] = "EnterpriseWebStoreURL";
const char kExtensionAllowedTypes[] = "ExtensionAllowedTypes";
const char kExtensionCacheSize[] = "ExtensionCacheSize";
const char kExtensionInstallBlacklist[] = "ExtensionInstallBlacklist";
const char kExtensionInstallForcelist[] = "ExtensionInstallForcelist";
const char kExtensionInstallSources[] = "ExtensionInstallSources";
const char kExtensionInstallWhitelist[] = "ExtensionInstallWhitelist";
const char kExtensionSettings[] = "ExtensionSettings";
const char kExternalStorageDisabled[] = "ExternalStorageDisabled";
const char kExternalStorageReadOnly[] = "ExternalStorageReadOnly";
const char kForceBrowserSignin[] = "ForceBrowserSignin";
const char kForceEphemeralProfiles[] = "ForceEphemeralProfiles";
const char kForceGoogleSafeSearch[] = "ForceGoogleSafeSearch";
const char kForceMaximizeOnFirstRun[] = "ForceMaximizeOnFirstRun";
const char kForceNetworkInProcess[] = "ForceNetworkInProcess";
const char kForceSafeSearch[] = "ForceSafeSearch";
const char kForceYouTubeRestrict[] = "ForceYouTubeRestrict";
const char kForceYouTubeSafetyMode[] = "ForceYouTubeSafetyMode";
const char kFullscreenAllowed[] = "FullscreenAllowed";
const char kGCFUserDataDir[] = "GCFUserDataDir";
const char kGSSAPILibraryName[] = "GSSAPILibraryName";
const char kHardwareAccelerationModeEnabled[] = "HardwareAccelerationModeEnabled";
const char kHeartbeatEnabled[] = "HeartbeatEnabled";
const char kHeartbeatFrequency[] = "HeartbeatFrequency";
const char kHideWebStoreIcon[] = "HideWebStoreIcon";
const char kHideWebStorePromo[] = "HideWebStorePromo";
const char kHighContrastEnabled[] = "HighContrastEnabled";
const char kHomepageIsNewTabPage[] = "HomepageIsNewTabPage";
const char kHomepageLocation[] = "HomepageLocation";
const char kHttp09OnNonDefaultPortsEnabled[] = "Http09OnNonDefaultPortsEnabled";
const char kIdleAction[] = "IdleAction";
const char kIdleActionAC[] = "IdleActionAC";
const char kIdleActionBattery[] = "IdleActionBattery";
const char kIdleDelayAC[] = "IdleDelayAC";
const char kIdleDelayBattery[] = "IdleDelayBattery";
const char kIdleWarningDelayAC[] = "IdleWarningDelayAC";
const char kIdleWarningDelayBattery[] = "IdleWarningDelayBattery";
const char kImagesAllowedForUrls[] = "ImagesAllowedForUrls";
const char kImagesBlockedForUrls[] = "ImagesBlockedForUrls";
const char kImportAutofillFormData[] = "ImportAutofillFormData";
const char kImportBookmarks[] = "ImportBookmarks";
const char kImportHistory[] = "ImportHistory";
const char kImportHomepage[] = "ImportHomepage";
const char kImportSavedPasswords[] = "ImportSavedPasswords";
const char kImportSearchEngine[] = "ImportSearchEngine";
const char kIncognitoEnabled[] = "IncognitoEnabled";
const char kIncognitoModeAvailability[] = "IncognitoModeAvailability";
const char kInstantEnabled[] = "InstantEnabled";
const char kInstantTetheringAllowed[] = "InstantTetheringAllowed";
const char kIsolateOrigins[] = "IsolateOrigins";
const char kIsolateOriginsAndroid[] = "IsolateOriginsAndroid";
const char kJavaScriptAllowedForUrls[] = "JavaScriptAllowedForUrls";
const char kJavaScriptBlockedForUrls[] = "JavaScriptBlockedForUrls";
const char kJavascriptEnabled[] = "JavascriptEnabled";
const char kKeyPermissions[] = "KeyPermissions";
const char kKeyboardDefaultToFunctionKeys[] = "KeyboardDefaultToFunctionKeys";
const char kKeygenAllowedForUrls[] = "KeygenAllowedForUrls";
const char kKeygenBlockedForUrls[] = "KeygenBlockedForUrls";
const char kLargeCursorEnabled[] = "LargeCursorEnabled";
const char kLidCloseAction[] = "LidCloseAction";
const char kLogUploadEnabled[] = "LogUploadEnabled";
const char kLoginAuthenticationBehavior[] = "LoginAuthenticationBehavior";
const char kLoginVideoCaptureAllowedUrls[] = "LoginVideoCaptureAllowedUrls";
const char kMachineLevelUserCloudPolicyEnrollmentToken[] = "MachineLevelUserCloudPolicyEnrollmentToken";
const char kManagedBookmarks[] = "ManagedBookmarks";
const char kMaxConnectionsPerProxy[] = "MaxConnectionsPerProxy";
const char kMaxInvalidationFetchDelay[] = "MaxInvalidationFetchDelay";
const char kMediaCacheSize[] = "MediaCacheSize";
const char kMediaRouterCastAllowAllIPs[] = "MediaRouterCastAllowAllIPs";
const char kMetricsReportingEnabled[] = "MetricsReportingEnabled";
const char kMinimumRequiredChromeVersion[] = "MinimumRequiredChromeVersion";
const char kNTLMShareAuthenticationEnabled[] = "NTLMShareAuthenticationEnabled";
const char kNTPContentSuggestionsEnabled[] = "NTPContentSuggestionsEnabled";
const char kNativeMessagingBlacklist[] = "NativeMessagingBlacklist";
const char kNativeMessagingUserLevelHosts[] = "NativeMessagingUserLevelHosts";
const char kNativeMessagingWhitelist[] = "NativeMessagingWhitelist";
const char kNativePrinters[] = "NativePrinters";
const char kNativePrintersBulkAccessMode[] = "NativePrintersBulkAccessMode";
const char kNativePrintersBulkBlacklist[] = "NativePrintersBulkBlacklist";
const char kNativePrintersBulkConfiguration[] = "NativePrintersBulkConfiguration";
const char kNativePrintersBulkWhitelist[] = "NativePrintersBulkWhitelist";
const char kNetBiosShareDiscoveryEnabled[] = "NetBiosShareDiscoveryEnabled";
const char kNetworkFileSharesAllowed[] = "NetworkFileSharesAllowed";
const char kNetworkFileSharesPreconfiguredShares[] = "NetworkFileSharesPreconfiguredShares";
const char kNetworkPredictionOptions[] = "NetworkPredictionOptions";
const char kNetworkThrottlingEnabled[] = "NetworkThrottlingEnabled";
const char kNewTabPageLocation[] = "NewTabPageLocation";
const char kNoteTakingAppsLockScreenWhitelist[] = "NoteTakingAppsLockScreenWhitelist";
const char kNotificationsAllowedForUrls[] = "NotificationsAllowedForUrls";
const char kNotificationsBlockedForUrls[] = "NotificationsBlockedForUrls";
const char kNtlmV2Enabled[] = "NtlmV2Enabled";
const char kOpenNetworkConfiguration[] = "OpenNetworkConfiguration";
const char kOverrideSecurityRestrictionsOnInsecureOrigin[] = "OverrideSecurityRestrictionsOnInsecureOrigin";
const char kPacHttpsUrlStrippingEnabled[] = "PacHttpsUrlStrippingEnabled";
const char kPasswordManagerAllowShowPasswords[] = "PasswordManagerAllowShowPasswords";
const char kPasswordManagerEnabled[] = "PasswordManagerEnabled";
const char kPasswordProtectionChangePasswordURL[] = "PasswordProtectionChangePasswordURL";
const char kPasswordProtectionLoginURLs[] = "PasswordProtectionLoginURLs";
const char kPasswordProtectionWarningTrigger[] = "PasswordProtectionWarningTrigger";
const char kPinUnlockMaximumLength[] = "PinUnlockMaximumLength";
const char kPinUnlockMinimumLength[] = "PinUnlockMinimumLength";
const char kPinUnlockWeakPinsAllowed[] = "PinUnlockWeakPinsAllowed";
const char kPinnedLauncherApps[] = "PinnedLauncherApps";
const char kPluginVmAllowed[] = "PluginVmAllowed";
const char kPluginVmImage[] = "PluginVmImage";
const char kPluginsAllowedForUrls[] = "PluginsAllowedForUrls";
const char kPluginsBlockedForUrls[] = "PluginsBlockedForUrls";
const char kPolicyRefreshRate[] = "PolicyRefreshRate";
const char kPopupsAllowedForUrls[] = "PopupsAllowedForUrls";
const char kPopupsBlockedForUrls[] = "PopupsBlockedForUrls";
const char kPowerManagementIdleSettings[] = "PowerManagementIdleSettings";
const char kPowerManagementUsesAudioActivity[] = "PowerManagementUsesAudioActivity";
const char kPowerManagementUsesVideoActivity[] = "PowerManagementUsesVideoActivity";
const char kPowerSmartDimEnabled[] = "PowerSmartDimEnabled";
const char kPresentationIdleDelayScale[] = "PresentationIdleDelayScale";
const char kPresentationScreenDimDelayScale[] = "PresentationScreenDimDelayScale";
const char kPrintHeaderFooter[] = "PrintHeaderFooter";
const char kPrintPreviewUseSystemDefaultPrinter[] = "PrintPreviewUseSystemDefaultPrinter";
const char kPrintingAllowedColorModes[] = "PrintingAllowedColorModes";
const char kPrintingAllowedDuplexModes[] = "PrintingAllowedDuplexModes";
const char kPrintingAllowedPageSizes[] = "PrintingAllowedPageSizes";
const char kPrintingColorDefault[] = "PrintingColorDefault";
const char kPrintingDuplexDefault[] = "PrintingDuplexDefault";
const char kPrintingEnabled[] = "PrintingEnabled";
const char kPrintingSizeDefault[] = "PrintingSizeDefault";
const char kPromotionalTabsEnabled[] = "PromotionalTabsEnabled";
const char kPromptForDownloadLocation[] = "PromptForDownloadLocation";
const char kProxyBypassList[] = "ProxyBypassList";
const char kProxyMode[] = "ProxyMode";
const char kProxyPacUrl[] = "ProxyPacUrl";
const char kProxyServer[] = "ProxyServer";
const char kProxyServerMode[] = "ProxyServerMode";
const char kProxySettings[] = "ProxySettings";
const char kQuicAllowed[] = "QuicAllowed";
const char kQuickUnlockModeWhitelist[] = "QuickUnlockModeWhitelist";
const char kQuickUnlockTimeout[] = "QuickUnlockTimeout";
const char kRC4Enabled[] = "RC4Enabled";
const char kRebootAfterUpdate[] = "RebootAfterUpdate";
const char kRegisteredProtocolHandlers[] = "RegisteredProtocolHandlers";
const char kRelaunchNotification[] = "RelaunchNotification";
const char kRelaunchNotificationPeriod[] = "RelaunchNotificationPeriod";
const char kRemoteAccessClientFirewallTraversal[] = "RemoteAccessClientFirewallTraversal";
const char kRemoteAccessHostAllowClientPairing[] = "RemoteAccessHostAllowClientPairing";
const char kRemoteAccessHostAllowGnubbyAuth[] = "RemoteAccessHostAllowGnubbyAuth";
const char kRemoteAccessHostAllowRelayedConnection[] = "RemoteAccessHostAllowRelayedConnection";
const char kRemoteAccessHostAllowUiAccessForRemoteAssistance[] = "RemoteAccessHostAllowUiAccessForRemoteAssistance";
const char kRemoteAccessHostClientDomain[] = "RemoteAccessHostClientDomain";
const char kRemoteAccessHostClientDomainList[] = "RemoteAccessHostClientDomainList";
const char kRemoteAccessHostDebugOverridePolicies[] = "RemoteAccessHostDebugOverridePolicies";
const char kRemoteAccessHostDomain[] = "RemoteAccessHostDomain";
const char kRemoteAccessHostDomainList[] = "RemoteAccessHostDomainList";
const char kRemoteAccessHostFirewallTraversal[] = "RemoteAccessHostFirewallTraversal";
const char kRemoteAccessHostMatchUsername[] = "RemoteAccessHostMatchUsername";
const char kRemoteAccessHostRequireCurtain[] = "RemoteAccessHostRequireCurtain";
const char kRemoteAccessHostRequireTwoFactor[] = "RemoteAccessHostRequireTwoFactor";
const char kRemoteAccessHostTalkGadgetPrefix[] = "RemoteAccessHostTalkGadgetPrefix";
const char kRemoteAccessHostTokenUrl[] = "RemoteAccessHostTokenUrl";
const char kRemoteAccessHostTokenValidationCertificateIssuer[] = "RemoteAccessHostTokenValidationCertificateIssuer";
const char kRemoteAccessHostTokenValidationUrl[] = "RemoteAccessHostTokenValidationUrl";
const char kRemoteAccessHostUdpPortRange[] = "RemoteAccessHostUdpPortRange";
const char kRenderInChromeFrameList[] = "RenderInChromeFrameList";
const char kRenderInHostList[] = "RenderInHostList";
const char kReportArcStatusEnabled[] = "ReportArcStatusEnabled";
const char kReportCrostiniUsageEnabled[] = "ReportCrostiniUsageEnabled";
const char kReportDeviceActivityTimes[] = "ReportDeviceActivityTimes";
const char kReportDeviceBootMode[] = "ReportDeviceBootMode";
const char kReportDeviceHardwareStatus[] = "ReportDeviceHardwareStatus";
const char kReportDeviceLocation[] = "ReportDeviceLocation";
const char kReportDeviceNetworkInterfaces[] = "ReportDeviceNetworkInterfaces";
const char kReportDeviceSessionStatus[] = "ReportDeviceSessionStatus";
const char kReportDeviceUsers[] = "ReportDeviceUsers";
const char kReportDeviceVersionInfo[] = "ReportDeviceVersionInfo";
const char kReportExtensionsAndPluginsData[] = "ReportExtensionsAndPluginsData";
const char kReportMachineIDData[] = "ReportMachineIDData";
const char kReportPolicyData[] = "ReportPolicyData";
const char kReportSafeBrowsingData[] = "ReportSafeBrowsingData";
const char kReportUploadFrequency[] = "ReportUploadFrequency";
const char kReportUserIDData[] = "ReportUserIDData";
const char kReportVersionData[] = "ReportVersionData";
const char kRequireOnlineRevocationChecksForLocalAnchors[] = "RequireOnlineRevocationChecksForLocalAnchors";
const char kRestoreOnStartup[] = "RestoreOnStartup";
const char kRestoreOnStartupURLs[] = "RestoreOnStartupURLs";
const char kRestrictAccountsToPatterns[] = "RestrictAccountsToPatterns";
const char kRestrictSigninToPattern[] = "RestrictSigninToPattern";
const char kRoamingProfileLocation[] = "RoamingProfileLocation";
const char kRoamingProfileSupportEnabled[] = "RoamingProfileSupportEnabled";
const char kRunAllFlashInAllowMode[] = "RunAllFlashInAllowMode";
const char kSAMLOfflineSigninTimeLimit[] = "SAMLOfflineSigninTimeLimit";
const char kSSLErrorOverrideAllowed[] = "SSLErrorOverrideAllowed";
const char kSSLVersionFallbackMin[] = "SSLVersionFallbackMin";
const char kSSLVersionMax[] = "SSLVersionMax";
const char kSSLVersionMin[] = "SSLVersionMin";
const char kSafeBrowsingEnabled[] = "SafeBrowsingEnabled";
const char kSafeBrowsingExtendedReportingEnabled[] = "SafeBrowsingExtendedReportingEnabled";
const char kSafeBrowsingExtendedReportingOptInAllowed[] = "SafeBrowsingExtendedReportingOptInAllowed";
const char kSafeBrowsingForTrustedSourcesEnabled[] = "SafeBrowsingForTrustedSourcesEnabled";
const char kSafeBrowsingWhitelistDomains[] = "SafeBrowsingWhitelistDomains";
const char kSafeSitesFilterBehavior[] = "SafeSitesFilterBehavior";
const char kSavingBrowserHistoryDisabled[] = "SavingBrowserHistoryDisabled";
const char kScreenBrightnessPercent[] = "ScreenBrightnessPercent";
const char kScreenDimDelayAC[] = "ScreenDimDelayAC";
const char kScreenDimDelayBattery[] = "ScreenDimDelayBattery";
const char kScreenLockDelayAC[] = "ScreenLockDelayAC";
const char kScreenLockDelayBattery[] = "ScreenLockDelayBattery";
const char kScreenLockDelays[] = "ScreenLockDelays";
const char kScreenMagnifierType[] = "ScreenMagnifierType";
const char kScreenOffDelayAC[] = "ScreenOffDelayAC";
const char kScreenOffDelayBattery[] = "ScreenOffDelayBattery";
const char kSearchSuggestEnabled[] = "SearchSuggestEnabled";
const char kSecondaryGoogleAccountSigninAllowed[] = "SecondaryGoogleAccountSigninAllowed";
const char kSecurityKeyPermitAttestation[] = "SecurityKeyPermitAttestation";
const char kSessionLengthLimit[] = "SessionLengthLimit";
const char kSessionLocales[] = "SessionLocales";
const char kShelfAutoHideBehavior[] = "ShelfAutoHideBehavior";
const char kShowAccessibilityOptionsInSystemTrayMenu[] = "ShowAccessibilityOptionsInSystemTrayMenu";
const char kShowAppsShortcutInBookmarkBar[] = "ShowAppsShortcutInBookmarkBar";
const char kShowCastIconInToolbar[] = "ShowCastIconInToolbar";
const char kShowHomeButton[] = "ShowHomeButton";
const char kShowLogoutButtonInTray[] = "ShowLogoutButtonInTray";
const char kSigninAllowed[] = "SigninAllowed";
const char kSitePerProcess[] = "SitePerProcess";
const char kSitePerProcessAndroid[] = "SitePerProcessAndroid";
const char kSkipMetadataCheck[] = "SkipMetadataCheck";
const char kSmartLockSigninAllowed[] = "SmartLockSigninAllowed";
const char kSmsMessagesAllowed[] = "SmsMessagesAllowed";
const char kSpellCheckServiceEnabled[] = "SpellCheckServiceEnabled";
const char kSpellcheckEnabled[] = "SpellcheckEnabled";
const char kSpellcheckLanguage[] = "SpellcheckLanguage";
const char kSpokenFeedbackEnabled[] = "SpokenFeedbackEnabled";
const char kSupervisedUserContentProviderEnabled[] = "SupervisedUserContentProviderEnabled";
const char kSupervisedUserCreationEnabled[] = "SupervisedUserCreationEnabled";
const char kSupervisedUsersEnabled[] = "SupervisedUsersEnabled";
const char kSuppressChromeFrameTurndownPrompt[] = "SuppressChromeFrameTurndownPrompt";
const char kSuppressUnsupportedOSWarning[] = "SuppressUnsupportedOSWarning";
const char kSyncDisabled[] = "SyncDisabled";
const char kSystemTimezone[] = "SystemTimezone";
const char kSystemTimezoneAutomaticDetection[] = "SystemTimezoneAutomaticDetection";
const char kSystemUse24HourClock[] = "SystemUse24HourClock";
const char kTPMFirmwareUpdateSettings[] = "TPMFirmwareUpdateSettings";
const char kTabLifecyclesEnabled[] = "TabLifecyclesEnabled";
const char kTabUnderAllowed[] = "TabUnderAllowed";
const char kTaskManagerEndProcessEnabled[] = "TaskManagerEndProcessEnabled";
const char kTermsOfServiceURL[] = "TermsOfServiceURL";
const char kThirdPartyBlockingEnabled[] = "ThirdPartyBlockingEnabled";
const char kTouchVirtualKeyboardEnabled[] = "TouchVirtualKeyboardEnabled";
const char kTranslateEnabled[] = "TranslateEnabled";
const char kURLBlacklist[] = "URLBlacklist";
const char kURLWhitelist[] = "URLWhitelist";
const char kUnaffiliatedArcAllowed[] = "UnaffiliatedArcAllowed";
const char kUnifiedDesktopEnabledByDefault[] = "UnifiedDesktopEnabledByDefault";
const char kUnsafelyTreatInsecureOriginAsSecure[] = "UnsafelyTreatInsecureOriginAsSecure";
const char kUptimeLimit[] = "UptimeLimit";
const char kUrlKeyedAnonymizedDataCollectionEnabled[] = "UrlKeyedAnonymizedDataCollectionEnabled";
const char kUsageTimeLimit[] = "UsageTimeLimit";
const char kUsbDetachableWhitelist[] = "UsbDetachableWhitelist";
const char kUserActivityScreenDimDelayScale[] = "UserActivityScreenDimDelayScale";
const char kUserAvatarImage[] = "UserAvatarImage";
const char kUserDataDir[] = "UserDataDir";
const char kUserDisplayName[] = "UserDisplayName";
const char kUserNativePrintersAllowed[] = "UserNativePrintersAllowed";
const char kVariationsRestrictParameter[] = "VariationsRestrictParameter";
const char kVideoCaptureAllowed[] = "VideoCaptureAllowed";
const char kVideoCaptureAllowedUrls[] = "VideoCaptureAllowedUrls";
const char kVirtualKeyboardEnabled[] = "VirtualKeyboardEnabled";
const char kVirtualMachinesAllowed[] = "VirtualMachinesAllowed";
const char kVpnConfigAllowed[] = "VpnConfigAllowed";
const char kWPADQuickCheckEnabled[] = "WPADQuickCheckEnabled";
const char kWaitForInitialUserActivity[] = "WaitForInitialUserActivity";
const char kWallpaperImage[] = "WallpaperImage";
const char kWebAppInstallForceList[] = "WebAppInstallForceList";
const char kWebDriverOverridesIncompatiblePolicies[] = "WebDriverOverridesIncompatiblePolicies";
const char kWebRestrictionsAuthority[] = "WebRestrictionsAuthority";
const char kWebRtcEventLogCollectionAllowed[] = "WebRtcEventLogCollectionAllowed";
const char kWebRtcUdpPortRange[] = "WebRtcUdpPortRange";
const char kWebUsbAllowDevicesForUrls[] = "WebUsbAllowDevicesForUrls";
const char kWebUsbAskForUrls[] = "WebUsbAskForUrls";
const char kWebUsbBlockedForUrls[] = "WebUsbBlockedForUrls";
const char kWelcomePageOnOSUpgradeEnabled[] = "WelcomePageOnOSUpgradeEnabled";

}  // namespace key

const IntegerPolicyAccess kIntegerPolicyAccess[] = {
  {key::kAdsSettingForIntrusiveAdsSites,
   &em::CloudPolicySettings::has_adssettingforintrusiveadssites,
   &em::CloudPolicySettings::adssettingforintrusiveadssites},
  {key::kBrowserSignin,
   &em::CloudPolicySettings::has_browsersignin,
   &em::CloudPolicySettings::browsersignin},
  {key::kContentPackDefaultFilteringBehavior,
   &em::CloudPolicySettings::has_contentpackdefaultfilteringbehavior,
   &em::CloudPolicySettings::contentpackdefaultfilteringbehavior},
  {key::kDefaultCookiesSetting,
   &em::CloudPolicySettings::has_defaultcookiessetting,
   &em::CloudPolicySettings::defaultcookiessetting},
  {key::kDefaultGeolocationSetting,
   &em::CloudPolicySettings::has_defaultgeolocationsetting,
   &em::CloudPolicySettings::defaultgeolocationsetting},
  {key::kDefaultImagesSetting,
   &em::CloudPolicySettings::has_defaultimagessetting,
   &em::CloudPolicySettings::defaultimagessetting},
  {key::kDefaultJavaScriptSetting,
   &em::CloudPolicySettings::has_defaultjavascriptsetting,
   &em::CloudPolicySettings::defaultjavascriptsetting},
  {key::kDefaultMediaStreamSetting,
   &em::CloudPolicySettings::has_defaultmediastreamsetting,
   &em::CloudPolicySettings::defaultmediastreamsetting},
  {key::kDefaultNotificationsSetting,
   &em::CloudPolicySettings::has_defaultnotificationssetting,
   &em::CloudPolicySettings::defaultnotificationssetting},
  {key::kDefaultPluginsSetting,
   &em::CloudPolicySettings::has_defaultpluginssetting,
   &em::CloudPolicySettings::defaultpluginssetting},
  {key::kDefaultPopupsSetting,
   &em::CloudPolicySettings::has_defaultpopupssetting,
   &em::CloudPolicySettings::defaultpopupssetting},
  {key::kDefaultWebBluetoothGuardSetting,
   &em::CloudPolicySettings::has_defaultwebbluetoothguardsetting,
   &em::CloudPolicySettings::defaultwebbluetoothguardsetting},
  {key::kDefaultWebUsbGuardSetting,
   &em::CloudPolicySettings::has_defaultwebusbguardsetting,
   &em::CloudPolicySettings::defaultwebusbguardsetting},
  {key::kDeveloperToolsAvailability,
   &em::CloudPolicySettings::has_developertoolsavailability,
   &em::CloudPolicySettings::developertoolsavailability},
  {key::kDiskCacheSize,
   &em::CloudPolicySettings::has_diskcachesize,
   &em::CloudPolicySettings::diskcachesize},
  {key::kDownloadRestrictions,
   &em::CloudPolicySettings::has_downloadrestrictions,
   &em::CloudPolicySettings::downloadrestrictions},
  {key::kForceYouTubeRestrict,
   &em::CloudPolicySettings::has_forceyoutuberestrict,
   &em::CloudPolicySettings::forceyoutuberestrict},
  {key::kIncognitoModeAvailability,
   &em::CloudPolicySettings::has_incognitomodeavailability,
   &em::CloudPolicySettings::incognitomodeavailability},
  {key::kMaxConnectionsPerProxy,
   &em::CloudPolicySettings::has_maxconnectionsperproxy,
   &em::CloudPolicySettings::maxconnectionsperproxy},
  {key::kMaxInvalidationFetchDelay,
   &em::CloudPolicySettings::has_maxinvalidationfetchdelay,
   &em::CloudPolicySettings::maxinvalidationfetchdelay},
  {key::kMediaCacheSize,
   &em::CloudPolicySettings::has_mediacachesize,
   &em::CloudPolicySettings::mediacachesize},
  {key::kNetworkPredictionOptions,
   &em::CloudPolicySettings::has_networkpredictionoptions,
   &em::CloudPolicySettings::networkpredictionoptions},
  {key::kPasswordProtectionWarningTrigger,
   &em::CloudPolicySettings::has_passwordprotectionwarningtrigger,
   &em::CloudPolicySettings::passwordprotectionwarningtrigger},
  {key::kProxyServerMode,
   &em::CloudPolicySettings::has_proxyservermode,
   &em::CloudPolicySettings::proxyservermode},
  {key::kRelaunchNotification,
   &em::CloudPolicySettings::has_relaunchnotification,
   &em::CloudPolicySettings::relaunchnotification},
  {key::kRelaunchNotificationPeriod,
   &em::CloudPolicySettings::has_relaunchnotificationperiod,
   &em::CloudPolicySettings::relaunchnotificationperiod},
  {key::kRestoreOnStartup,
   &em::CloudPolicySettings::has_restoreonstartup,
   &em::CloudPolicySettings::restoreonstartup},
  {key::kSafeSitesFilterBehavior,
   &em::CloudPolicySettings::has_safesitesfilterbehavior,
   &em::CloudPolicySettings::safesitesfilterbehavior},
  {nullptr, nullptr, nullptr},
};

const BooleanPolicyAccess kBooleanPolicyAccess[] = {
  {key::kAbusiveExperienceInterventionEnforce,
   &em::CloudPolicySettings::has_abusiveexperienceinterventionenforce,
   &em::CloudPolicySettings::abusiveexperienceinterventionenforce},
  {key::kAllowCrossOriginAuthPrompt,
   &em::CloudPolicySettings::has_allowcrossoriginauthprompt,
   &em::CloudPolicySettings::allowcrossoriginauthprompt},
  {key::kAllowDeletingBrowserHistory,
   &em::CloudPolicySettings::has_allowdeletingbrowserhistory,
   &em::CloudPolicySettings::allowdeletingbrowserhistory},
  {key::kAllowDinosaurEasterEgg,
   &em::CloudPolicySettings::has_allowdinosaureasteregg,
   &em::CloudPolicySettings::allowdinosaureasteregg},
  {key::kAllowFileSelectionDialogs,
   &em::CloudPolicySettings::has_allowfileselectiondialogs,
   &em::CloudPolicySettings::allowfileselectiondialogs},
  {key::kAllowOutdatedPlugins,
   &em::CloudPolicySettings::has_allowoutdatedplugins,
   &em::CloudPolicySettings::allowoutdatedplugins},
  {key::kAlternateErrorPagesEnabled,
   &em::CloudPolicySettings::has_alternateerrorpagesenabled,
   &em::CloudPolicySettings::alternateerrorpagesenabled},
  {key::kAlwaysOpenPdfExternally,
   &em::CloudPolicySettings::has_alwaysopenpdfexternally,
   &em::CloudPolicySettings::alwaysopenpdfexternally},
  {key::kAudioCaptureAllowed,
   &em::CloudPolicySettings::has_audiocaptureallowed,
   &em::CloudPolicySettings::audiocaptureallowed},
  {key::kAutoFillEnabled,
   &em::CloudPolicySettings::has_autofillenabled,
   &em::CloudPolicySettings::autofillenabled},
  {key::kAutofillAddressEnabled,
   &em::CloudPolicySettings::has_autofilladdressenabled,
   &em::CloudPolicySettings::autofilladdressenabled},
  {key::kAutofillCreditCardEnabled,
   &em::CloudPolicySettings::has_autofillcreditcardenabled,
   &em::CloudPolicySettings::autofillcreditcardenabled},
  {key::kAutoplayAllowed,
   &em::CloudPolicySettings::has_autoplayallowed,
   &em::CloudPolicySettings::autoplayallowed},
  {key::kBackgroundModeEnabled,
   &em::CloudPolicySettings::has_backgroundmodeenabled,
   &em::CloudPolicySettings::backgroundmodeenabled},
  {key::kBlockThirdPartyCookies,
   &em::CloudPolicySettings::has_blockthirdpartycookies,
   &em::CloudPolicySettings::blockthirdpartycookies},
  {key::kBookmarkBarEnabled,
   &em::CloudPolicySettings::has_bookmarkbarenabled,
   &em::CloudPolicySettings::bookmarkbarenabled},
  {key::kBrowserAddPersonEnabled,
   &em::CloudPolicySettings::has_browseraddpersonenabled,
   &em::CloudPolicySettings::browseraddpersonenabled},
  {key::kBrowserGuestModeEnabled,
   &em::CloudPolicySettings::has_browserguestmodeenabled,
   &em::CloudPolicySettings::browserguestmodeenabled},
  {key::kBrowserNetworkTimeQueriesEnabled,
   &em::CloudPolicySettings::has_browsernetworktimequeriesenabled,
   &em::CloudPolicySettings::browsernetworktimequeriesenabled},
  {key::kBuiltInDnsClientEnabled,
   &em::CloudPolicySettings::has_builtindnsclientenabled,
   &em::CloudPolicySettings::builtindnsclientenabled},
  {key::kCloudManagementEnrollmentMandatory,
   &em::CloudPolicySettings::has_cloudmanagementenrollmentmandatory,
   &em::CloudPolicySettings::cloudmanagementenrollmentmandatory},
  {key::kCloudPolicyOverridesMachinePolicy,
   &em::CloudPolicySettings::has_cloudpolicyoverridesmachinepolicy,
   &em::CloudPolicySettings::cloudpolicyoverridesmachinepolicy},
  {key::kCloudPrintProxyEnabled,
   &em::CloudPolicySettings::has_cloudprintproxyenabled,
   &em::CloudPolicySettings::cloudprintproxyenabled},
  {key::kCloudPrintSubmitEnabled,
   &em::CloudPolicySettings::has_cloudprintsubmitenabled,
   &em::CloudPolicySettings::cloudprintsubmitenabled},
  {key::kCloudReportingEnabled,
   &em::CloudPolicySettings::has_cloudreportingenabled,
   &em::CloudPolicySettings::cloudreportingenabled},
  {key::kComponentUpdatesEnabled,
   &em::CloudPolicySettings::has_componentupdatesenabled,
   &em::CloudPolicySettings::componentupdatesenabled},
  {key::kDefaultBrowserSettingEnabled,
   &em::CloudPolicySettings::has_defaultbrowsersettingenabled,
   &em::CloudPolicySettings::defaultbrowsersettingenabled},
  {key::kDefaultSearchProviderEnabled,
   &em::CloudPolicySettings::has_defaultsearchproviderenabled,
   &em::CloudPolicySettings::defaultsearchproviderenabled},
  {key::kDeveloperToolsDisabled,
   &em::CloudPolicySettings::has_developertoolsdisabled,
   &em::CloudPolicySettings::developertoolsdisabled},
  {key::kDisable3DAPIs,
   &em::CloudPolicySettings::has_disable3dapis,
   &em::CloudPolicySettings::disable3dapis},
  {key::kDisableAuthNegotiateCnameLookup,
   &em::CloudPolicySettings::has_disableauthnegotiatecnamelookup,
   &em::CloudPolicySettings::disableauthnegotiatecnamelookup},
  {key::kDisablePrintPreview,
   &em::CloudPolicySettings::has_disableprintpreview,
   &em::CloudPolicySettings::disableprintpreview},
  {key::kDisableSafeBrowsingProceedAnyway,
   &em::CloudPolicySettings::has_disablesafebrowsingproceedanyway,
   &em::CloudPolicySettings::disablesafebrowsingproceedanyway},
  {key::kDisableScreenshots,
   &em::CloudPolicySettings::has_disablescreenshots,
   &em::CloudPolicySettings::disablescreenshots},
  {key::kEditBookmarksEnabled,
   &em::CloudPolicySettings::has_editbookmarksenabled,
   &em::CloudPolicySettings::editbookmarksenabled},
  {key::kEnableAuthNegotiatePort,
   &em::CloudPolicySettings::has_enableauthnegotiateport,
   &em::CloudPolicySettings::enableauthnegotiateport},
  {key::kEnableMediaRouter,
   &em::CloudPolicySettings::has_enablemediarouter,
   &em::CloudPolicySettings::enablemediarouter},
  {key::kEnableOnlineRevocationChecks,
   &em::CloudPolicySettings::has_enableonlinerevocationchecks,
   &em::CloudPolicySettings::enableonlinerevocationchecks},
  {key::kEnableSymantecLegacyInfrastructure,
   &em::CloudPolicySettings::has_enablesymanteclegacyinfrastructure,
   &em::CloudPolicySettings::enablesymanteclegacyinfrastructure},
  {key::kEnterpriseHardwarePlatformAPIEnabled,
   &em::CloudPolicySettings::has_enterprisehardwareplatformapienabled,
   &em::CloudPolicySettings::enterprisehardwareplatformapienabled},
  {key::kForceEphemeralProfiles,
   &em::CloudPolicySettings::has_forceephemeralprofiles,
   &em::CloudPolicySettings::forceephemeralprofiles},
  {key::kForceGoogleSafeSearch,
   &em::CloudPolicySettings::has_forcegooglesafesearch,
   &em::CloudPolicySettings::forcegooglesafesearch},
  {key::kForceSafeSearch,
   &em::CloudPolicySettings::has_forcesafesearch,
   &em::CloudPolicySettings::forcesafesearch},
  {key::kForceYouTubeSafetyMode,
   &em::CloudPolicySettings::has_forceyoutubesafetymode,
   &em::CloudPolicySettings::forceyoutubesafetymode},
  {key::kFullscreenAllowed,
   &em::CloudPolicySettings::has_fullscreenallowed,
   &em::CloudPolicySettings::fullscreenallowed},
  {key::kHardwareAccelerationModeEnabled,
   &em::CloudPolicySettings::has_hardwareaccelerationmodeenabled,
   &em::CloudPolicySettings::hardwareaccelerationmodeenabled},
  {key::kHideWebStoreIcon,
   &em::CloudPolicySettings::has_hidewebstoreicon,
   &em::CloudPolicySettings::hidewebstoreicon},
  {key::kHomepageIsNewTabPage,
   &em::CloudPolicySettings::has_homepageisnewtabpage,
   &em::CloudPolicySettings::homepageisnewtabpage},
  {key::kHttp09OnNonDefaultPortsEnabled,
   &em::CloudPolicySettings::has_http09onnondefaultportsenabled,
   &em::CloudPolicySettings::http09onnondefaultportsenabled},
  {key::kImportAutofillFormData,
   &em::CloudPolicySettings::has_importautofillformdata,
   &em::CloudPolicySettings::importautofillformdata},
  {key::kImportBookmarks,
   &em::CloudPolicySettings::has_importbookmarks,
   &em::CloudPolicySettings::importbookmarks},
  {key::kImportHistory,
   &em::CloudPolicySettings::has_importhistory,
   &em::CloudPolicySettings::importhistory},
  {key::kImportHomepage,
   &em::CloudPolicySettings::has_importhomepage,
   &em::CloudPolicySettings::importhomepage},
  {key::kImportSavedPasswords,
   &em::CloudPolicySettings::has_importsavedpasswords,
   &em::CloudPolicySettings::importsavedpasswords},
  {key::kImportSearchEngine,
   &em::CloudPolicySettings::has_importsearchengine,
   &em::CloudPolicySettings::importsearchengine},
  {key::kIncognitoEnabled,
   &em::CloudPolicySettings::has_incognitoenabled,
   &em::CloudPolicySettings::incognitoenabled},
  {key::kJavascriptEnabled,
   &em::CloudPolicySettings::has_javascriptenabled,
   &em::CloudPolicySettings::javascriptenabled},
  {key::kMediaRouterCastAllowAllIPs,
   &em::CloudPolicySettings::has_mediaroutercastallowallips,
   &em::CloudPolicySettings::mediaroutercastallowallips},
  {key::kMetricsReportingEnabled,
   &em::CloudPolicySettings::has_metricsreportingenabled,
   &em::CloudPolicySettings::metricsreportingenabled},
  {key::kNativeMessagingUserLevelHosts,
   &em::CloudPolicySettings::has_nativemessaginguserlevelhosts,
   &em::CloudPolicySettings::nativemessaginguserlevelhosts},
  {key::kNtlmV2Enabled,
   &em::CloudPolicySettings::has_ntlmv2enabled,
   &em::CloudPolicySettings::ntlmv2enabled},
  {key::kPacHttpsUrlStrippingEnabled,
   &em::CloudPolicySettings::has_pachttpsurlstrippingenabled,
   &em::CloudPolicySettings::pachttpsurlstrippingenabled},
  {key::kPasswordManagerEnabled,
   &em::CloudPolicySettings::has_passwordmanagerenabled,
   &em::CloudPolicySettings::passwordmanagerenabled},
  {key::kPrintHeaderFooter,
   &em::CloudPolicySettings::has_printheaderfooter,
   &em::CloudPolicySettings::printheaderfooter},
  {key::kPrintPreviewUseSystemDefaultPrinter,
   &em::CloudPolicySettings::has_printpreviewusesystemdefaultprinter,
   &em::CloudPolicySettings::printpreviewusesystemdefaultprinter},
  {key::kPrintingEnabled,
   &em::CloudPolicySettings::has_printingenabled,
   &em::CloudPolicySettings::printingenabled},
  {key::kPromotionalTabsEnabled,
   &em::CloudPolicySettings::has_promotionaltabsenabled,
   &em::CloudPolicySettings::promotionaltabsenabled},
  {key::kPromptForDownloadLocation,
   &em::CloudPolicySettings::has_promptfordownloadlocation,
   &em::CloudPolicySettings::promptfordownloadlocation},
  {key::kQuicAllowed,
   &em::CloudPolicySettings::has_quicallowed,
   &em::CloudPolicySettings::quicallowed},
  {key::kRemoteAccessHostAllowClientPairing,
   &em::CloudPolicySettings::has_remoteaccesshostallowclientpairing,
   &em::CloudPolicySettings::remoteaccesshostallowclientpairing},
  {key::kRemoteAccessHostAllowGnubbyAuth,
   &em::CloudPolicySettings::has_remoteaccesshostallowgnubbyauth,
   &em::CloudPolicySettings::remoteaccesshostallowgnubbyauth},
  {key::kRemoteAccessHostAllowRelayedConnection,
   &em::CloudPolicySettings::has_remoteaccesshostallowrelayedconnection,
   &em::CloudPolicySettings::remoteaccesshostallowrelayedconnection},
  {key::kRemoteAccessHostFirewallTraversal,
   &em::CloudPolicySettings::has_remoteaccesshostfirewalltraversal,
   &em::CloudPolicySettings::remoteaccesshostfirewalltraversal},
  {key::kRemoteAccessHostMatchUsername,
   &em::CloudPolicySettings::has_remoteaccesshostmatchusername,
   &em::CloudPolicySettings::remoteaccesshostmatchusername},
  {key::kRemoteAccessHostRequireCurtain,
   &em::CloudPolicySettings::has_remoteaccesshostrequirecurtain,
   &em::CloudPolicySettings::remoteaccesshostrequirecurtain},
  {key::kReportExtensionsAndPluginsData,
   &em::CloudPolicySettings::has_reportextensionsandpluginsdata,
   &em::CloudPolicySettings::reportextensionsandpluginsdata},
  {key::kReportMachineIDData,
   &em::CloudPolicySettings::has_reportmachineiddata,
   &em::CloudPolicySettings::reportmachineiddata},
  {key::kReportPolicyData,
   &em::CloudPolicySettings::has_reportpolicydata,
   &em::CloudPolicySettings::reportpolicydata},
  {key::kReportSafeBrowsingData,
   &em::CloudPolicySettings::has_reportsafebrowsingdata,
   &em::CloudPolicySettings::reportsafebrowsingdata},
  {key::kReportUserIDData,
   &em::CloudPolicySettings::has_reportuseriddata,
   &em::CloudPolicySettings::reportuseriddata},
  {key::kReportVersionData,
   &em::CloudPolicySettings::has_reportversiondata,
   &em::CloudPolicySettings::reportversiondata},
  {key::kRequireOnlineRevocationChecksForLocalAnchors,
   &em::CloudPolicySettings::has_requireonlinerevocationchecksforlocalanchors,
   &em::CloudPolicySettings::requireonlinerevocationchecksforlocalanchors},
  {key::kRunAllFlashInAllowMode,
   &em::CloudPolicySettings::has_runallflashinallowmode,
   &em::CloudPolicySettings::runallflashinallowmode},
  {key::kSSLErrorOverrideAllowed,
   &em::CloudPolicySettings::has_sslerroroverrideallowed,
   &em::CloudPolicySettings::sslerroroverrideallowed},
  {key::kSafeBrowsingEnabled,
   &em::CloudPolicySettings::has_safebrowsingenabled,
   &em::CloudPolicySettings::safebrowsingenabled},
  {key::kSafeBrowsingExtendedReportingEnabled,
   &em::CloudPolicySettings::has_safebrowsingextendedreportingenabled,
   &em::CloudPolicySettings::safebrowsingextendedreportingenabled},
  {key::kSafeBrowsingExtendedReportingOptInAllowed,
   &em::CloudPolicySettings::has_safebrowsingextendedreportingoptinallowed,
   &em::CloudPolicySettings::safebrowsingextendedreportingoptinallowed},
  {key::kSavingBrowserHistoryDisabled,
   &em::CloudPolicySettings::has_savingbrowserhistorydisabled,
   &em::CloudPolicySettings::savingbrowserhistorydisabled},
  {key::kSearchSuggestEnabled,
   &em::CloudPolicySettings::has_searchsuggestenabled,
   &em::CloudPolicySettings::searchsuggestenabled},
  {key::kShowAppsShortcutInBookmarkBar,
   &em::CloudPolicySettings::has_showappsshortcutinbookmarkbar,
   &em::CloudPolicySettings::showappsshortcutinbookmarkbar},
  {key::kShowCastIconInToolbar,
   &em::CloudPolicySettings::has_showcasticonintoolbar,
   &em::CloudPolicySettings::showcasticonintoolbar},
  {key::kShowHomeButton,
   &em::CloudPolicySettings::has_showhomebutton,
   &em::CloudPolicySettings::showhomebutton},
  {key::kSigninAllowed,
   &em::CloudPolicySettings::has_signinallowed,
   &em::CloudPolicySettings::signinallowed},
  {key::kSitePerProcess,
   &em::CloudPolicySettings::has_siteperprocess,
   &em::CloudPolicySettings::siteperprocess},
  {key::kSpellCheckServiceEnabled,
   &em::CloudPolicySettings::has_spellcheckserviceenabled,
   &em::CloudPolicySettings::spellcheckserviceenabled},
  {key::kSpellcheckEnabled,
   &em::CloudPolicySettings::has_spellcheckenabled,
   &em::CloudPolicySettings::spellcheckenabled},
  {key::kSuppressUnsupportedOSWarning,
   &em::CloudPolicySettings::has_suppressunsupportedoswarning,
   &em::CloudPolicySettings::suppressunsupportedoswarning},
  {key::kSyncDisabled,
   &em::CloudPolicySettings::has_syncdisabled,
   &em::CloudPolicySettings::syncdisabled},
  {key::kTaskManagerEndProcessEnabled,
   &em::CloudPolicySettings::has_taskmanagerendprocessenabled,
   &em::CloudPolicySettings::taskmanagerendprocessenabled},
  {key::kTranslateEnabled,
   &em::CloudPolicySettings::has_translateenabled,
   &em::CloudPolicySettings::translateenabled},
  {key::kUrlKeyedAnonymizedDataCollectionEnabled,
   &em::CloudPolicySettings::has_urlkeyedanonymizeddatacollectionenabled,
   &em::CloudPolicySettings::urlkeyedanonymizeddatacollectionenabled},
  {key::kVideoCaptureAllowed,
   &em::CloudPolicySettings::has_videocaptureallowed,
   &em::CloudPolicySettings::videocaptureallowed},
  {key::kWPADQuickCheckEnabled,
   &em::CloudPolicySettings::has_wpadquickcheckenabled,
   &em::CloudPolicySettings::wpadquickcheckenabled},
  {key::kWebDriverOverridesIncompatiblePolicies,
   &em::CloudPolicySettings::has_webdriveroverridesincompatiblepolicies,
   &em::CloudPolicySettings::webdriveroverridesincompatiblepolicies},
  {key::kWebRtcEventLogCollectionAllowed,
   &em::CloudPolicySettings::has_webrtceventlogcollectionallowed,
   &em::CloudPolicySettings::webrtceventlogcollectionallowed},
  {nullptr, nullptr, nullptr},
};

const StringPolicyAccess kStringPolicyAccess[] = {
  {key::kAllowedDomainsForApps,
   &em::CloudPolicySettings::has_alloweddomainsforapps,
   &em::CloudPolicySettings::alloweddomainsforapps,
   StringPolicyType::STRING},
  {key::kAlternativeBrowserPath,
   &em::CloudPolicySettings::has_alternativebrowserpath,
   &em::CloudPolicySettings::alternativebrowserpath,
   StringPolicyType::STRING},
  {key::kAuthNegotiateDelegateWhitelist,
   &em::CloudPolicySettings::has_authnegotiatedelegatewhitelist,
   &em::CloudPolicySettings::authnegotiatedelegatewhitelist,
   StringPolicyType::STRING},
  {key::kAuthSchemes,
   &em::CloudPolicySettings::has_authschemes,
   &em::CloudPolicySettings::authschemes,
   StringPolicyType::STRING},
  {key::kAuthServerWhitelist,
   &em::CloudPolicySettings::has_authserverwhitelist,
   &em::CloudPolicySettings::authserverwhitelist,
   StringPolicyType::STRING},
  {key::kContentPackManualBehaviorHosts,
   &em::CloudPolicySettings::has_contentpackmanualbehaviorhosts,
   &em::CloudPolicySettings::contentpackmanualbehaviorhosts,
   StringPolicyType::JSON},
  {key::kContentPackManualBehaviorURLs,
   &em::CloudPolicySettings::has_contentpackmanualbehaviorurls,
   &em::CloudPolicySettings::contentpackmanualbehaviorurls,
   StringPolicyType::JSON},
  {key::kDefaultDownloadDirectory,
   &em::CloudPolicySettings::has_defaultdownloaddirectory,
   &em::CloudPolicySettings::defaultdownloaddirectory,
   StringPolicyType::STRING},
  {key::kDefaultPrinterSelection,
   &em::CloudPolicySettings::has_defaultprinterselection,
   &em::CloudPolicySettings::defaultprinterselection,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderIconURL,
   &em::CloudPolicySettings::has_defaultsearchprovidericonurl,
   &em::CloudPolicySettings::defaultsearchprovidericonurl,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderImageURL,
   &em::CloudPolicySettings::has_defaultsearchproviderimageurl,
   &em::CloudPolicySettings::defaultsearchproviderimageurl,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderImageURLPostParams,
   &em::CloudPolicySettings::has_defaultsearchproviderimageurlpostparams,
   &em::CloudPolicySettings::defaultsearchproviderimageurlpostparams,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderKeyword,
   &em::CloudPolicySettings::has_defaultsearchproviderkeyword,
   &em::CloudPolicySettings::defaultsearchproviderkeyword,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderName,
   &em::CloudPolicySettings::has_defaultsearchprovidername,
   &em::CloudPolicySettings::defaultsearchprovidername,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderNewTabURL,
   &em::CloudPolicySettings::has_defaultsearchprovidernewtaburl,
   &em::CloudPolicySettings::defaultsearchprovidernewtaburl,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderSearchURL,
   &em::CloudPolicySettings::has_defaultsearchprovidersearchurl,
   &em::CloudPolicySettings::defaultsearchprovidersearchurl,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderSearchURLPostParams,
   &em::CloudPolicySettings::has_defaultsearchprovidersearchurlpostparams,
   &em::CloudPolicySettings::defaultsearchprovidersearchurlpostparams,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderSuggestURL,
   &em::CloudPolicySettings::has_defaultsearchprovidersuggesturl,
   &em::CloudPolicySettings::defaultsearchprovidersuggesturl,
   StringPolicyType::STRING},
  {key::kDefaultSearchProviderSuggestURLPostParams,
   &em::CloudPolicySettings::has_defaultsearchprovidersuggesturlpostparams,
   &em::CloudPolicySettings::defaultsearchprovidersuggesturlpostparams,
   StringPolicyType::STRING},
  {key::kDiskCacheDir,
   &em::CloudPolicySettings::has_diskcachedir,
   &em::CloudPolicySettings::diskcachedir,
   StringPolicyType::STRING},
  {key::kDownloadDirectory,
   &em::CloudPolicySettings::has_downloaddirectory,
   &em::CloudPolicySettings::downloaddirectory,
   StringPolicyType::STRING},
  {key::kExtensionSettings,
   &em::CloudPolicySettings::has_extensionsettings,
   &em::CloudPolicySettings::extensionsettings,
   StringPolicyType::JSON},
  {key::kGSSAPILibraryName,
   &em::CloudPolicySettings::has_gssapilibraryname,
   &em::CloudPolicySettings::gssapilibraryname,
   StringPolicyType::STRING},
  {key::kHomepageLocation,
   &em::CloudPolicySettings::has_homepagelocation,
   &em::CloudPolicySettings::homepagelocation,
   StringPolicyType::STRING},
  {key::kIsolateOrigins,
   &em::CloudPolicySettings::has_isolateorigins,
   &em::CloudPolicySettings::isolateorigins,
   StringPolicyType::STRING},
  {key::kMachineLevelUserCloudPolicyEnrollmentToken,
   &em::CloudPolicySettings::has_machinelevelusercloudpolicyenrollmenttoken,
   &em::CloudPolicySettings::machinelevelusercloudpolicyenrollmenttoken,
   StringPolicyType::STRING},
  {key::kManagedBookmarks,
   &em::CloudPolicySettings::has_managedbookmarks,
   &em::CloudPolicySettings::managedbookmarks,
   StringPolicyType::JSON},
  {key::kNewTabPageLocation,
   &em::CloudPolicySettings::has_newtabpagelocation,
   &em::CloudPolicySettings::newtabpagelocation,
   StringPolicyType::STRING},
  {key::kPasswordProtectionChangePasswordURL,
   &em::CloudPolicySettings::has_passwordprotectionchangepasswordurl,
   &em::CloudPolicySettings::passwordprotectionchangepasswordurl,
   StringPolicyType::STRING},
  {key::kProxyBypassList,
   &em::CloudPolicySettings::has_proxybypasslist,
   &em::CloudPolicySettings::proxybypasslist,
   StringPolicyType::STRING},
  {key::kProxyMode,
   &em::CloudPolicySettings::has_proxymode,
   &em::CloudPolicySettings::proxymode,
   StringPolicyType::STRING},
  {key::kProxyPacUrl,
   &em::CloudPolicySettings::has_proxypacurl,
   &em::CloudPolicySettings::proxypacurl,
   StringPolicyType::STRING},
  {key::kProxyServer,
   &em::CloudPolicySettings::has_proxyserver,
   &em::CloudPolicySettings::proxyserver,
   StringPolicyType::STRING},
  {key::kProxySettings,
   &em::CloudPolicySettings::has_proxysettings,
   &em::CloudPolicySettings::proxysettings,
   StringPolicyType::JSON},
  {key::kRegisteredProtocolHandlers,
   &em::CloudPolicySettings::has_registeredprotocolhandlers,
   &em::CloudPolicySettings::registeredprotocolhandlers,
   StringPolicyType::JSON},
  {key::kRemoteAccessHostClientDomain,
   &em::CloudPolicySettings::has_remoteaccesshostclientdomain,
   &em::CloudPolicySettings::remoteaccesshostclientdomain,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostDomain,
   &em::CloudPolicySettings::has_remoteaccesshostdomain,
   &em::CloudPolicySettings::remoteaccesshostdomain,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostTalkGadgetPrefix,
   &em::CloudPolicySettings::has_remoteaccesshosttalkgadgetprefix,
   &em::CloudPolicySettings::remoteaccesshosttalkgadgetprefix,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostTokenUrl,
   &em::CloudPolicySettings::has_remoteaccesshosttokenurl,
   &em::CloudPolicySettings::remoteaccesshosttokenurl,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostTokenValidationCertificateIssuer,
   &em::CloudPolicySettings::has_remoteaccesshosttokenvalidationcertificateissuer,
   &em::CloudPolicySettings::remoteaccesshosttokenvalidationcertificateissuer,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostTokenValidationUrl,
   &em::CloudPolicySettings::has_remoteaccesshosttokenvalidationurl,
   &em::CloudPolicySettings::remoteaccesshosttokenvalidationurl,
   StringPolicyType::STRING},
  {key::kRemoteAccessHostUdpPortRange,
   &em::CloudPolicySettings::has_remoteaccesshostudpportrange,
   &em::CloudPolicySettings::remoteaccesshostudpportrange,
   StringPolicyType::STRING},
  {key::kRestrictSigninToPattern,
   &em::CloudPolicySettings::has_restrictsignintopattern,
   &em::CloudPolicySettings::restrictsignintopattern,
   StringPolicyType::STRING},
  {key::kSSLVersionMax,
   &em::CloudPolicySettings::has_sslversionmax,
   &em::CloudPolicySettings::sslversionmax,
   StringPolicyType::STRING},
  {key::kSSLVersionMin,
   &em::CloudPolicySettings::has_sslversionmin,
   &em::CloudPolicySettings::sslversionmin,
   StringPolicyType::STRING},
  {key::kVariationsRestrictParameter,
   &em::CloudPolicySettings::has_variationsrestrictparameter,
   &em::CloudPolicySettings::variationsrestrictparameter,
   StringPolicyType::STRING},
  {key::kWebRtcUdpPortRange,
   &em::CloudPolicySettings::has_webrtcudpportrange,
   &em::CloudPolicySettings::webrtcudpportrange,
   StringPolicyType::STRING},
  {key::kWebUsbAllowDevicesForUrls,
   &em::CloudPolicySettings::has_webusballowdevicesforurls,
   &em::CloudPolicySettings::webusballowdevicesforurls,
   StringPolicyType::JSON},
  {nullptr, nullptr, nullptr},
};

const StringListPolicyAccess kStringListPolicyAccess[] = {
  {key::kAlternativeBrowserParameters,
   &em::CloudPolicySettings::has_alternativebrowserparameters,
   &em::CloudPolicySettings::alternativebrowserparameters},
  {key::kAudioCaptureAllowedUrls,
   &em::CloudPolicySettings::has_audiocaptureallowedurls,
   &em::CloudPolicySettings::audiocaptureallowedurls},
  {key::kAutoSelectCertificateForUrls,
   &em::CloudPolicySettings::has_autoselectcertificateforurls,
   &em::CloudPolicySettings::autoselectcertificateforurls},
  {key::kAutoplayWhitelist,
   &em::CloudPolicySettings::has_autoplaywhitelist,
   &em::CloudPolicySettings::autoplaywhitelist},
  {key::kBrowserSwitcherUrlGreylist,
   &em::CloudPolicySettings::has_browserswitcherurlgreylist,
   &em::CloudPolicySettings::browserswitcherurlgreylist},
  {key::kBrowserSwitcherUrlList,
   &em::CloudPolicySettings::has_browserswitcherurllist,
   &em::CloudPolicySettings::browserswitcherurllist},
  {key::kCertificateTransparencyEnforcementDisabledForCas,
   &em::CloudPolicySettings::has_certificatetransparencyenforcementdisabledforcas,
   &em::CloudPolicySettings::certificatetransparencyenforcementdisabledforcas},
  {key::kCertificateTransparencyEnforcementDisabledForLegacyCas,
   &em::CloudPolicySettings::has_certificatetransparencyenforcementdisabledforlegacycas,
   &em::CloudPolicySettings::certificatetransparencyenforcementdisabledforlegacycas},
  {key::kCertificateTransparencyEnforcementDisabledForUrls,
   &em::CloudPolicySettings::has_certificatetransparencyenforcementdisabledforurls,
   &em::CloudPolicySettings::certificatetransparencyenforcementdisabledforurls},
  {key::kCoalesceH2ConnectionsWithClientCertificatesForHosts,
   &em::CloudPolicySettings::has_coalesceh2connectionswithclientcertificatesforhosts,
   &em::CloudPolicySettings::coalesceh2connectionswithclientcertificatesforhosts},
  {key::kCookiesAllowedForUrls,
   &em::CloudPolicySettings::has_cookiesallowedforurls,
   &em::CloudPolicySettings::cookiesallowedforurls},
  {key::kCookiesBlockedForUrls,
   &em::CloudPolicySettings::has_cookiesblockedforurls,
   &em::CloudPolicySettings::cookiesblockedforurls},
  {key::kCookiesSessionOnlyForUrls,
   &em::CloudPolicySettings::has_cookiessessiononlyforurls,
   &em::CloudPolicySettings::cookiessessiononlyforurls},
  {key::kDefaultSearchProviderAlternateURLs,
   &em::CloudPolicySettings::has_defaultsearchprovideralternateurls,
   &em::CloudPolicySettings::defaultsearchprovideralternateurls},
  {key::kDefaultSearchProviderEncodings,
   &em::CloudPolicySettings::has_defaultsearchproviderencodings,
   &em::CloudPolicySettings::defaultsearchproviderencodings},
  {key::kDisabledPlugins,
   &em::CloudPolicySettings::has_disabledplugins,
   &em::CloudPolicySettings::disabledplugins},
  {key::kDisabledPluginsExceptions,
   &em::CloudPolicySettings::has_disabledpluginsexceptions,
   &em::CloudPolicySettings::disabledpluginsexceptions},
  {key::kDisabledSchemes,
   &em::CloudPolicySettings::has_disabledschemes,
   &em::CloudPolicySettings::disabledschemes},
  {key::kEnableDeprecatedWebPlatformFeatures,
   &em::CloudPolicySettings::has_enabledeprecatedwebplatformfeatures,
   &em::CloudPolicySettings::enabledeprecatedwebplatformfeatures},
  {key::kEnabledPlugins,
   &em::CloudPolicySettings::has_enabledplugins,
   &em::CloudPolicySettings::enabledplugins},
  {key::kExtensionAllowedTypes,
   &em::CloudPolicySettings::has_extensionallowedtypes,
   &em::CloudPolicySettings::extensionallowedtypes},
  {key::kExtensionInstallBlacklist,
   &em::CloudPolicySettings::has_extensioninstallblacklist,
   &em::CloudPolicySettings::extensioninstallblacklist},
  {key::kExtensionInstallForcelist,
   &em::CloudPolicySettings::has_extensioninstallforcelist,
   &em::CloudPolicySettings::extensioninstallforcelist},
  {key::kExtensionInstallSources,
   &em::CloudPolicySettings::has_extensioninstallsources,
   &em::CloudPolicySettings::extensioninstallsources},
  {key::kExtensionInstallWhitelist,
   &em::CloudPolicySettings::has_extensioninstallwhitelist,
   &em::CloudPolicySettings::extensioninstallwhitelist},
  {key::kImagesAllowedForUrls,
   &em::CloudPolicySettings::has_imagesallowedforurls,
   &em::CloudPolicySettings::imagesallowedforurls},
  {key::kImagesBlockedForUrls,
   &em::CloudPolicySettings::has_imagesblockedforurls,
   &em::CloudPolicySettings::imagesblockedforurls},
  {key::kJavaScriptAllowedForUrls,
   &em::CloudPolicySettings::has_javascriptallowedforurls,
   &em::CloudPolicySettings::javascriptallowedforurls},
  {key::kJavaScriptBlockedForUrls,
   &em::CloudPolicySettings::has_javascriptblockedforurls,
   &em::CloudPolicySettings::javascriptblockedforurls},
  {key::kNativeMessagingBlacklist,
   &em::CloudPolicySettings::has_nativemessagingblacklist,
   &em::CloudPolicySettings::nativemessagingblacklist},
  {key::kNativeMessagingWhitelist,
   &em::CloudPolicySettings::has_nativemessagingwhitelist,
   &em::CloudPolicySettings::nativemessagingwhitelist},
  {key::kNotificationsAllowedForUrls,
   &em::CloudPolicySettings::has_notificationsallowedforurls,
   &em::CloudPolicySettings::notificationsallowedforurls},
  {key::kNotificationsBlockedForUrls,
   &em::CloudPolicySettings::has_notificationsblockedforurls,
   &em::CloudPolicySettings::notificationsblockedforurls},
  {key::kOverrideSecurityRestrictionsOnInsecureOrigin,
   &em::CloudPolicySettings::has_overridesecurityrestrictionsoninsecureorigin,
   &em::CloudPolicySettings::overridesecurityrestrictionsoninsecureorigin},
  {key::kPasswordProtectionLoginURLs,
   &em::CloudPolicySettings::has_passwordprotectionloginurls,
   &em::CloudPolicySettings::passwordprotectionloginurls},
  {key::kPluginsAllowedForUrls,
   &em::CloudPolicySettings::has_pluginsallowedforurls,
   &em::CloudPolicySettings::pluginsallowedforurls},
  {key::kPluginsBlockedForUrls,
   &em::CloudPolicySettings::has_pluginsblockedforurls,
   &em::CloudPolicySettings::pluginsblockedforurls},
  {key::kPopupsAllowedForUrls,
   &em::CloudPolicySettings::has_popupsallowedforurls,
   &em::CloudPolicySettings::popupsallowedforurls},
  {key::kPopupsBlockedForUrls,
   &em::CloudPolicySettings::has_popupsblockedforurls,
   &em::CloudPolicySettings::popupsblockedforurls},
  {key::kRemoteAccessHostClientDomainList,
   &em::CloudPolicySettings::has_remoteaccesshostclientdomainlist,
   &em::CloudPolicySettings::remoteaccesshostclientdomainlist},
  {key::kRemoteAccessHostDomainList,
   &em::CloudPolicySettings::has_remoteaccesshostdomainlist,
   &em::CloudPolicySettings::remoteaccesshostdomainlist},
  {key::kRestoreOnStartupURLs,
   &em::CloudPolicySettings::has_restoreonstartupurls,
   &em::CloudPolicySettings::restoreonstartupurls},
  {key::kSafeBrowsingWhitelistDomains,
   &em::CloudPolicySettings::has_safebrowsingwhitelistdomains,
   &em::CloudPolicySettings::safebrowsingwhitelistdomains},
  {key::kSecurityKeyPermitAttestation,
   &em::CloudPolicySettings::has_securitykeypermitattestation,
   &em::CloudPolicySettings::securitykeypermitattestation},
  {key::kSpellcheckLanguage,
   &em::CloudPolicySettings::has_spellchecklanguage,
   &em::CloudPolicySettings::spellchecklanguage},
  {key::kURLBlacklist,
   &em::CloudPolicySettings::has_urlblacklist,
   &em::CloudPolicySettings::urlblacklist},
  {key::kURLWhitelist,
   &em::CloudPolicySettings::has_urlwhitelist,
   &em::CloudPolicySettings::urlwhitelist},
  {key::kUnsafelyTreatInsecureOriginAsSecure,
   &em::CloudPolicySettings::has_unsafelytreatinsecureoriginassecure,
   &em::CloudPolicySettings::unsafelytreatinsecureoriginassecure},
  {key::kVideoCaptureAllowedUrls,
   &em::CloudPolicySettings::has_videocaptureallowedurls,
   &em::CloudPolicySettings::videocaptureallowedurls},
  {key::kWebUsbAskForUrls,
   &em::CloudPolicySettings::has_webusbaskforurls,
   &em::CloudPolicySettings::webusbaskforurls},
  {key::kWebUsbBlockedForUrls,
   &em::CloudPolicySettings::has_webusbblockedforurls,
   &em::CloudPolicySettings::webusbblockedforurls},
  {nullptr, nullptr, nullptr},
};


}  // namespace policy
