// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/device/public/mojom/bluetooth_system.mojom-shared.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace device {
namespace mojom {
class BluetoothSystemFactory;
using BluetoothSystemFactoryPtr = mojo::InterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryPtrInfo = mojo::InterfacePtrInfo<BluetoothSystemFactory>;
using ThreadSafeBluetoothSystemFactoryPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryRequest = mojo::InterfaceRequest<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystemFactory>;
using ThreadSafeBluetoothSystemFactoryAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystemFactory>;

class BluetoothSystem;
using BluetoothSystemPtr = mojo::InterfacePtr<BluetoothSystem>;
using BluetoothSystemPtrInfo = mojo::InterfacePtrInfo<BluetoothSystem>;
using ThreadSafeBluetoothSystemPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystem>;
using BluetoothSystemRequest = mojo::InterfaceRequest<BluetoothSystem>;
using BluetoothSystemAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystem>;
using ThreadSafeBluetoothSystemAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystem>;
using BluetoothSystemAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystem>;
using BluetoothSystemAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystem>;

class BluetoothSystemClient;
using BluetoothSystemClientPtr = mojo::InterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientPtrInfo = mojo::InterfacePtrInfo<BluetoothSystemClient>;
using ThreadSafeBluetoothSystemClientPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientRequest = mojo::InterfaceRequest<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystemClient>;
using ThreadSafeBluetoothSystemClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystemClient>;

class BluetoothDeviceInfo;
using BluetoothDeviceInfoPtr = mojo::StructPtr<BluetoothDeviceInfo>;


class BluetoothSystemFactoryProxy;

template <typename ImplRefTraits>
class BluetoothSystemFactoryStub;

class BluetoothSystemFactoryRequestValidator;

class  BluetoothSystemFactory
    : public BluetoothSystemFactoryInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemFactoryStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemFactoryRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateMinVersion = 0,
  };
  virtual ~BluetoothSystemFactory() {}

  virtual void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) = 0;
};
class  BluetoothSystemFactoryInterceptorForTesting : public BluetoothSystemFactory {
  virtual BluetoothSystemFactory* GetForwardingInterface() = 0;
  void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) override;
};
class  BluetoothSystemFactoryAsyncWaiter {
 public:
  explicit BluetoothSystemFactoryAsyncWaiter(BluetoothSystemFactory* proxy);
  ~BluetoothSystemFactoryAsyncWaiter();

 private:
  BluetoothSystemFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemFactoryAsyncWaiter);
};

class BluetoothSystemProxy;

template <typename ImplRefTraits>
class BluetoothSystemStub;

class BluetoothSystemRequestValidator;
class BluetoothSystemResponseValidator;

class  BluetoothSystem
    : public BluetoothSystemInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemRequestValidator;
  using ResponseValidator_ = BluetoothSystemResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetStateMinVersion = 0,
    kSetPoweredMinVersion = 0,
    kGetScanStateMinVersion = 0,
    kStartScanMinVersion = 0,
    kStopScanMinVersion = 0,
  };
  using State = BluetoothSystem_State;
  using SetPoweredResult = BluetoothSystem_SetPoweredResult;
  using ScanState = BluetoothSystem_ScanState;
  using StartScanResult = BluetoothSystem_StartScanResult;
  using StopScanResult = BluetoothSystem_StopScanResult;
  virtual ~BluetoothSystem() {}


  using GetStateCallback = base::OnceCallback<void(BluetoothSystem::State)>;
  virtual void GetState(GetStateCallback callback) = 0;


  using SetPoweredCallback = base::OnceCallback<void(BluetoothSystem::SetPoweredResult)>;
  virtual void SetPowered(bool powered, SetPoweredCallback callback) = 0;


  using GetScanStateCallback = base::OnceCallback<void(BluetoothSystem::ScanState)>;
  virtual void GetScanState(GetScanStateCallback callback) = 0;


  using StartScanCallback = base::OnceCallback<void(BluetoothSystem::StartScanResult)>;
  virtual void StartScan(StartScanCallback callback) = 0;


  using StopScanCallback = base::OnceCallback<void(BluetoothSystem::StopScanResult)>;
  virtual void StopScan(StopScanCallback callback) = 0;
};
class  BluetoothSystemInterceptorForTesting : public BluetoothSystem {
  virtual BluetoothSystem* GetForwardingInterface() = 0;
  void GetState(GetStateCallback callback) override;
  void SetPowered(bool powered, SetPoweredCallback callback) override;
  void GetScanState(GetScanStateCallback callback) override;
  void StartScan(StartScanCallback callback) override;
  void StopScan(StopScanCallback callback) override;
};
class  BluetoothSystemAsyncWaiter {
 public:
  explicit BluetoothSystemAsyncWaiter(BluetoothSystem* proxy);
  ~BluetoothSystemAsyncWaiter();
  void GetState(
      BluetoothSystem::State* out_state);
  void SetPowered(
      bool powered, BluetoothSystem::SetPoweredResult* out_result);
  void GetScanState(
      BluetoothSystem::ScanState* out_scan_state);
  void StartScan(
      BluetoothSystem::StartScanResult* out_result);
  void StopScan(
      BluetoothSystem::StopScanResult* out_result);

 private:
  BluetoothSystem* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemAsyncWaiter);
};

class BluetoothSystemClientProxy;

template <typename ImplRefTraits>
class BluetoothSystemClientStub;

class BluetoothSystemClientRequestValidator;

class  BluetoothSystemClient
    : public BluetoothSystemClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemClientStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnStateChangedMinVersion = 0,
    kOnScanStateChangedMinVersion = 0,
  };
  virtual ~BluetoothSystemClient() {}

  virtual void OnStateChanged(BluetoothSystem::State new_state) = 0;

  virtual void OnScanStateChanged(BluetoothSystem::ScanState new_state) = 0;
};
class  BluetoothSystemClientInterceptorForTesting : public BluetoothSystemClient {
  virtual BluetoothSystemClient* GetForwardingInterface() = 0;
  void OnStateChanged(BluetoothSystem::State new_state) override;
  void OnScanStateChanged(BluetoothSystem::ScanState new_state) override;
};
class  BluetoothSystemClientAsyncWaiter {
 public:
  explicit BluetoothSystemClientAsyncWaiter(BluetoothSystemClient* proxy);
  ~BluetoothSystemClientAsyncWaiter();

 private:
  BluetoothSystemClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemClientAsyncWaiter);
};

class  BluetoothSystemFactoryProxy
    : public BluetoothSystemFactory {
 public:
  explicit BluetoothSystemFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class  BluetoothSystemProxy
    : public BluetoothSystem {
 public:
  explicit BluetoothSystemProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetState(GetStateCallback callback) final;
  void SetPowered(bool powered, SetPoweredCallback callback) final;
  void GetScanState(GetScanStateCallback callback) final;
  void StartScan(StartScanCallback callback) final;
  void StopScan(StopScanCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class  BluetoothSystemClientProxy
    : public BluetoothSystemClient {
 public:
  explicit BluetoothSystemClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnStateChanged(BluetoothSystem::State new_state) final;
  void OnScanStateChanged(BluetoothSystem::ScanState new_state) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  BluetoothSystemFactoryStubDispatch {
 public:
  static bool Accept(BluetoothSystemFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystemFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystemFactory>>
class BluetoothSystemFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemFactoryStub() {}
  ~BluetoothSystemFactoryStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  BluetoothSystemStubDispatch {
 public:
  static bool Accept(BluetoothSystem* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystem* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystem>>
class BluetoothSystemStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemStub() {}
  ~BluetoothSystemStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  BluetoothSystemClientStubDispatch {
 public:
  static bool Accept(BluetoothSystemClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystemClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystemClient>>
class BluetoothSystemClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemClientStub() {}
  ~BluetoothSystemClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  BluetoothSystemFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  BluetoothSystemRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  BluetoothSystemClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  BluetoothSystemResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class  BluetoothDeviceInfo {
 public:
  using DataView = BluetoothDeviceInfoDataView;
  using Data_ = internal::BluetoothDeviceInfo_Data;using ConnectionState = BluetoothDeviceInfo_ConnectionState;using DeviceType = BluetoothDeviceInfo_DeviceType;

  template <typename... Args>
  static BluetoothDeviceInfoPtr New(Args&&... args) {
    return BluetoothDeviceInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static BluetoothDeviceInfoPtr From(const U& u) {
    return mojo::TypeConverter<BluetoothDeviceInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, BluetoothDeviceInfo>::Convert(*this);
  }


  BluetoothDeviceInfo();

  BluetoothDeviceInfo(
      const std::string& address,
      const base::Optional<std::string>& name,
      BluetoothDeviceInfo::ConnectionState connection_state,
      bool is_paired,
      BluetoothDeviceInfo::DeviceType device_type);

  ~BluetoothDeviceInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = BluetoothDeviceInfoPtr>
  BluetoothDeviceInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, BluetoothDeviceInfo>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        BluetoothDeviceInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        BluetoothDeviceInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::BluetoothDeviceInfo_UnserializedMessageContext<
            UserType, BluetoothDeviceInfo::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<BluetoothDeviceInfo::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return BluetoothDeviceInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::BluetoothDeviceInfo_UnserializedMessageContext<
            UserType, BluetoothDeviceInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<BluetoothDeviceInfo::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  std::string address;
  base::Optional<std::string> name;
  BluetoothDeviceInfo::ConnectionState connection_state;
  bool is_paired;
  BluetoothDeviceInfo::DeviceType device_type;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

template <typename StructPtrType>
BluetoothDeviceInfoPtr BluetoothDeviceInfo::Clone() const {
  return New(
      mojo::Clone(address),
      mojo::Clone(name),
      mojo::Clone(connection_state),
      mojo::Clone(is_paired),
      mojo::Clone(device_type)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, BluetoothDeviceInfo>::value>::type*>
bool BluetoothDeviceInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->address, other_struct.address))
    return false;
  if (!mojo::Equals(this->name, other_struct.name))
    return false;
  if (!mojo::Equals(this->connection_state, other_struct.connection_state))
    return false;
  if (!mojo::Equals(this->is_paired, other_struct.is_paired))
    return false;
  if (!mojo::Equals(this->device_type, other_struct.device_type))
    return false;
  return true;
}


}  // namespace mojom
}  // namespace device

namespace mojo {


template <>
struct  StructTraits<::device::mojom::BluetoothDeviceInfo::DataView,
                                         ::device::mojom::BluetoothDeviceInfoPtr> {
  static bool IsNull(const ::device::mojom::BluetoothDeviceInfoPtr& input) { return !input; }
  static void SetToNull(::device::mojom::BluetoothDeviceInfoPtr* output) { output->reset(); }

  static const decltype(::device::mojom::BluetoothDeviceInfo::address)& address(
      const ::device::mojom::BluetoothDeviceInfoPtr& input) {
    return input->address;
  }

  static const decltype(::device::mojom::BluetoothDeviceInfo::name)& name(
      const ::device::mojom::BluetoothDeviceInfoPtr& input) {
    return input->name;
  }

  static decltype(::device::mojom::BluetoothDeviceInfo::connection_state) connection_state(
      const ::device::mojom::BluetoothDeviceInfoPtr& input) {
    return input->connection_state;
  }

  static decltype(::device::mojom::BluetoothDeviceInfo::is_paired) is_paired(
      const ::device::mojom::BluetoothDeviceInfoPtr& input) {
    return input->is_paired;
  }

  static decltype(::device::mojom::BluetoothDeviceInfo::device_type) device_type(
      const ::device::mojom::BluetoothDeviceInfoPtr& input) {
    return input->device_type;
  }

  static bool Read(::device::mojom::BluetoothDeviceInfo::DataView input, ::device::mojom::BluetoothDeviceInfoPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_H_