// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/network/public/mojom/p2p_trusted.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/network/public/mojom/p2p_trusted.mojom-shared-message-ids.h"
namespace network {
namespace mojom {
const char P2PTrustedSocketManagerClient::Name_[] = "network.mojom.P2PTrustedSocketManagerClient";

P2PTrustedSocketManagerClientProxy::P2PTrustedSocketManagerClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message(
      uint32_t message_flags
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Name,
          message_flags){}
  ~P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message>(
          kFlags
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PTrustedSocketManagerClient* impl) {
    impl->InvalidSocketPortRangeRequested();
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  }

  DISALLOW_COPY_AND_ASSIGN(P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message::kMessageTag = {};

void P2PTrustedSocketManagerClientProxy::InvalidSocketPortRangeRequested(
    ) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PTrustedSocketManagerClient::InvalidSocketPortRangeRequested");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message::Build(
      kSerialize, kExpectsResponse, kIsSync);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PTrustedSocketManagerClient::Name_);
  message.set_method_name("InvalidSocketPortRangeRequested");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PTrustedSocketManagerClientProxy_DumpPacket_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PTrustedSocketManagerClientProxy_DumpPacket_Message(
      uint32_t message_flags
      , const std::vector<uint8_t>& param_packet_header
      , uint64_t param_packet_length
      , bool param_incoming
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PTrustedSocketManagerClient_DumpPacket_Name,
          message_flags)
      , param_packet_header_(std::move(param_packet_header))
      , param_packet_length_(std::move(param_packet_length))
      , param_incoming_(std::move(param_incoming)){}
  ~P2PTrustedSocketManagerClientProxy_DumpPacket_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      const std::vector<uint8_t>& param_packet_header, uint64_t param_packet_length, bool param_incoming) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PTrustedSocketManagerClientProxy_DumpPacket_Message>(
          kFlags
          , std::move(param_packet_header)
          , std::move(param_packet_length)
          , std::move(param_incoming)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PTrustedSocketManagerClient_DumpPacket_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PTrustedSocketManagerClient_DumpPacket_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->packet_header)::BaseType::BufferWriter
      packet_header_writer;
  const mojo::internal::ContainerValidateParams packet_header_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
      param_packet_header, buffer, &packet_header_writer, &packet_header_validate_params,
      &serialization_context);
  params->packet_header.Set(
      packet_header_writer.is_null() ? nullptr : packet_header_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->packet_header.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null packet_header in P2PTrustedSocketManagerClient.DumpPacket request");
  params->packet_length = param_packet_length;
  params->incoming = param_incoming;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PTrustedSocketManagerClient* impl) {
    impl->DumpPacket(
        std::move(param_packet_header_),
        std::move(param_packet_length_),
        std::move(param_incoming_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PTrustedSocketManagerClient_DumpPacket_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  typename decltype(params->packet_header)::BaseType::BufferWriter
      packet_header_writer;
  const mojo::internal::ContainerValidateParams packet_header_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<uint8_t>>(
      param_packet_header_, buffer, &packet_header_writer, &packet_header_validate_params,
      serialization_context);
  params->packet_header.Set(
      packet_header_writer.is_null() ? nullptr : packet_header_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->packet_header.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null packet_header in P2PTrustedSocketManagerClient.DumpPacket request");
  params->packet_length = param_packet_length_;
  params->incoming = param_incoming_;
  }
  std::vector<uint8_t> param_packet_header_;
  uint64_t param_packet_length_;
  bool param_incoming_;

  DISALLOW_COPY_AND_ASSIGN(P2PTrustedSocketManagerClientProxy_DumpPacket_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PTrustedSocketManagerClientProxy_DumpPacket_Message::kMessageTag = {};

void P2PTrustedSocketManagerClientProxy::DumpPacket(
    const std::vector<uint8_t>& in_packet_header, uint64_t in_packet_length, bool in_incoming) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PTrustedSocketManagerClient::DumpPacket");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PTrustedSocketManagerClientProxy_DumpPacket_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_packet_header), std::move(in_packet_length), std::move(in_incoming));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PTrustedSocketManagerClient::Name_);
  message.set_method_name("DumpPacket");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool P2PTrustedSocketManagerClientStubDispatch::Accept(
    P2PTrustedSocketManagerClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManagerClient::InvalidSocketPortRangeRequested",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PTrustedSocketManagerClientProxy_InvalidSocketPortRangeRequested_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data* params =
          reinterpret_cast<internal::P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PTrustedSocketManagerClient::InvalidSocketPortRangeRequested deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->InvalidSocketPortRangeRequested();
      return true;
    }
    case internal::kP2PTrustedSocketManagerClient_DumpPacket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManagerClient::DumpPacket",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PTrustedSocketManagerClientProxy_DumpPacket_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PTrustedSocketManagerClient_DumpPacket_Params_Data* params =
          reinterpret_cast<internal::P2PTrustedSocketManagerClient_DumpPacket_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<uint8_t> p_packet_header{};
      uint64_t p_packet_length{};
      bool p_incoming{};
      P2PTrustedSocketManagerClient_DumpPacket_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadPacketHeader(&p_packet_header))
        success = false;
      p_packet_length = input_data_view.packet_length();
      p_incoming = input_data_view.incoming();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PTrustedSocketManagerClient::DumpPacket deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->DumpPacket(
std::move(p_packet_header), 
std::move(p_packet_length), 
std::move(p_incoming));
      return true;
    }
  }
  return false;
}

// static
bool P2PTrustedSocketManagerClientStubDispatch::AcceptWithResponder(
    P2PTrustedSocketManagerClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManagerClient::InvalidSocketPortRangeRequested",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PTrustedSocketManagerClient_DumpPacket_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManagerClient::DumpPacket",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PTrustedSocketManagerClientRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PTrustedSocketManagerClient RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PTrustedSocketManagerClient_InvalidSocketPortRangeRequested_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PTrustedSocketManagerClient_DumpPacket_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PTrustedSocketManagerClient_DumpPacket_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void P2PTrustedSocketManagerClientInterceptorForTesting::InvalidSocketPortRangeRequested() {
  GetForwardingInterface()->InvalidSocketPortRangeRequested();
}
void P2PTrustedSocketManagerClientInterceptorForTesting::DumpPacket(const std::vector<uint8_t>& packet_header, uint64_t packet_length, bool incoming) {
  GetForwardingInterface()->DumpPacket(std::move(packet_header), std::move(packet_length), std::move(incoming));
}
P2PTrustedSocketManagerClientAsyncWaiter::P2PTrustedSocketManagerClientAsyncWaiter(
    P2PTrustedSocketManagerClient* proxy) : proxy_(proxy) {}

P2PTrustedSocketManagerClientAsyncWaiter::~P2PTrustedSocketManagerClientAsyncWaiter() = default;


const char P2PTrustedSocketManager::Name_[] = "network.mojom.P2PTrustedSocketManager";

P2PTrustedSocketManagerProxy::P2PTrustedSocketManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class P2PTrustedSocketManagerProxy_StartRtpDump_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PTrustedSocketManagerProxy_StartRtpDump_Message(
      uint32_t message_flags
      , bool param_incoming
      , bool param_outgoing
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PTrustedSocketManager_StartRtpDump_Name,
          message_flags)
      , param_incoming_(std::move(param_incoming))
      , param_outgoing_(std::move(param_outgoing)){}
  ~P2PTrustedSocketManagerProxy_StartRtpDump_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      bool param_incoming, bool param_outgoing) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PTrustedSocketManagerProxy_StartRtpDump_Message>(
          kFlags
          , std::move(param_incoming)
          , std::move(param_outgoing)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PTrustedSocketManager_StartRtpDump_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PTrustedSocketManager_StartRtpDump_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->incoming = param_incoming;
  params->outgoing = param_outgoing;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PTrustedSocketManager* impl) {
    impl->StartRtpDump(
        std::move(param_incoming_),
        std::move(param_outgoing_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PTrustedSocketManager_StartRtpDump_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  params->incoming = param_incoming_;
  params->outgoing = param_outgoing_;
  }
  bool param_incoming_;
  bool param_outgoing_;

  DISALLOW_COPY_AND_ASSIGN(P2PTrustedSocketManagerProxy_StartRtpDump_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PTrustedSocketManagerProxy_StartRtpDump_Message::kMessageTag = {};

void P2PTrustedSocketManagerProxy::StartRtpDump(
    bool in_incoming, bool in_outgoing) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PTrustedSocketManager::StartRtpDump");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PTrustedSocketManagerProxy_StartRtpDump_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_incoming), std::move(in_outgoing));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PTrustedSocketManager::Name_);
  message.set_method_name("StartRtpDump");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class P2PTrustedSocketManagerProxy_StopRtpDump_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit P2PTrustedSocketManagerProxy_StopRtpDump_Message(
      uint32_t message_flags
      , bool param_incoming
      , bool param_outgoing
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kP2PTrustedSocketManager_StopRtpDump_Name,
          message_flags)
      , param_incoming_(std::move(param_incoming))
      , param_outgoing_(std::move(param_outgoing)){}
  ~P2PTrustedSocketManagerProxy_StopRtpDump_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      bool param_incoming, bool param_outgoing) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<P2PTrustedSocketManagerProxy_StopRtpDump_Message>(
          kFlags
          , std::move(param_incoming)
          , std::move(param_outgoing)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kP2PTrustedSocketManager_StopRtpDump_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::P2PTrustedSocketManager_StopRtpDump_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->incoming = param_incoming;
  params->outgoing = param_outgoing;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(P2PTrustedSocketManager* impl) {
    impl->StopRtpDump(
        std::move(param_incoming_),
        std::move(param_outgoing_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::P2PTrustedSocketManager_StopRtpDump_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  params->incoming = param_incoming_;
  params->outgoing = param_outgoing_;
  }
  bool param_incoming_;
  bool param_outgoing_;

  DISALLOW_COPY_AND_ASSIGN(P2PTrustedSocketManagerProxy_StopRtpDump_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
P2PTrustedSocketManagerProxy_StopRtpDump_Message::kMessageTag = {};

void P2PTrustedSocketManagerProxy::StopRtpDump(
    bool in_incoming, bool in_outgoing) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::P2PTrustedSocketManager::StopRtpDump");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = P2PTrustedSocketManagerProxy_StopRtpDump_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_incoming), std::move(in_outgoing));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(P2PTrustedSocketManager::Name_);
  message.set_method_name("StopRtpDump");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool P2PTrustedSocketManagerStubDispatch::Accept(
    P2PTrustedSocketManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManager_StartRtpDump_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManager::StartRtpDump",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PTrustedSocketManagerProxy_StartRtpDump_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PTrustedSocketManager_StartRtpDump_Params_Data* params =
          reinterpret_cast<internal::P2PTrustedSocketManager_StartRtpDump_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_incoming{};
      bool p_outgoing{};
      P2PTrustedSocketManager_StartRtpDump_ParamsDataView input_data_view(params, &serialization_context);
      
      p_incoming = input_data_view.incoming();
      p_outgoing = input_data_view.outgoing();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PTrustedSocketManager::StartRtpDump deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StartRtpDump(
std::move(p_incoming), 
std::move(p_outgoing));
      return true;
    }
    case internal::kP2PTrustedSocketManager_StopRtpDump_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManager::StopRtpDump",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            P2PTrustedSocketManagerProxy_StopRtpDump_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::P2PTrustedSocketManager_StopRtpDump_Params_Data* params =
          reinterpret_cast<internal::P2PTrustedSocketManager_StopRtpDump_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_incoming{};
      bool p_outgoing{};
      P2PTrustedSocketManager_StopRtpDump_ParamsDataView input_data_view(params, &serialization_context);
      
      p_incoming = input_data_view.incoming();
      p_outgoing = input_data_view.outgoing();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "P2PTrustedSocketManager::StopRtpDump deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->StopRtpDump(
std::move(p_incoming), 
std::move(p_outgoing));
      return true;
    }
  }
  return false;
}

// static
bool P2PTrustedSocketManagerStubDispatch::AcceptWithResponder(
    P2PTrustedSocketManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManager_StartRtpDump_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManager::StartRtpDump",
               "message", message->name());
#endif
      break;
    }
    case internal::kP2PTrustedSocketManager_StopRtpDump_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::P2PTrustedSocketManager::StopRtpDump",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool P2PTrustedSocketManagerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "P2PTrustedSocketManager RequestValidator");

  switch (message->header()->name) {
    case internal::kP2PTrustedSocketManager_StartRtpDump_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PTrustedSocketManager_StartRtpDump_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kP2PTrustedSocketManager_StopRtpDump_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::P2PTrustedSocketManager_StopRtpDump_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void P2PTrustedSocketManagerInterceptorForTesting::StartRtpDump(bool incoming, bool outgoing) {
  GetForwardingInterface()->StartRtpDump(std::move(incoming), std::move(outgoing));
}
void P2PTrustedSocketManagerInterceptorForTesting::StopRtpDump(bool incoming, bool outgoing) {
  GetForwardingInterface()->StopRtpDump(std::move(incoming), std::move(outgoing));
}
P2PTrustedSocketManagerAsyncWaiter::P2PTrustedSocketManagerAsyncWaiter(
    P2PTrustedSocketManager* proxy) : proxy_(proxy) {}

P2PTrustedSocketManagerAsyncWaiter::~P2PTrustedSocketManagerAsyncWaiter() = default;


}  // namespace mojom
}  // namespace network

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif